////**************************************************************************
//	aisa25s.pas
//
//	aISA-A25Tv\[X
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/07/10
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
////**************************************************************************
unit aisa25s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa25w;

const
	szTitle = 'Sample';
	szA25	 = 'aISA-A25';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		function	StartProc(var pwLogSlot: Word): Boolean;
		function	EndProc(wLogSlot: Word): Boolean;
		function	AdProc(wLogSlot: Word): Boolean;
		function	DaProc(wLogSlot: Word): Boolean;
		function	PioProc(wLogSlot: Word): Boolean;

		function	AdProcGetNextChAddr(wFirst: Word; wLast: Word; wCur: Word): Word;
		procedure DaProcMakeSineData(pdwDataCount: PDWord; var pwData: PWord);

		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	wLogSlot:	 Word;				// _Xbg
begin

	//----------------------------------------------
	//	Jn
	//----------------------------------------------
	if StartProc(wLogSlot) = False then Exit;

	//----------------------------------------------
	//	A/D 
	//----------------------------------------------
	if AdProc(wLogSlot) = False then
	begin
		EndProc(wLogSlot);
		Exit;
	end;

	//----------------------------------------------
	//	D/A 
	//----------------------------------------------
	if DaProc(wLogSlot) = False then
	begin
		EndProc(wLogSlot);
		Exit;
	end;

	//----------------------------------------------
	//	PIO 
	//----------------------------------------------
	if PioProc(wLogSlot) = False then
	begin
		EndProc(wLogSlot);
		Exit;
	end;

	//----------------------------------------------
	//	I
	//----------------------------------------------
	if EndProc(wLogSlot) = False then Exit;

end;

//--------------------------------------------------------------------------
//	Jn
//--------------------------------------------------------------------------
function TForm1.StartProc(var pwLogSlot: Word): Boolean;
var
	strbuf:				 String;					// ƃobt@
	dwDLLVer, dwDrvVer: DWord;			// o[W
	bResult:			 Boolean;					// 
	wLogSlot:			 Word;						// _Xbg
	hWnd:					 THandle;					// EBhEnh
	InitArg:			 DWord;
	ri:						 TAISA25RESOURCE;	// \[X
	wNumBoard:		 Word;						// 䂷{[h
	dwSwitchValue: DWord;						// BSN

begin
	Result := False;

	//----------------------------------------------
	//	aisa25.dll ̎gp錾
	//----------------------------------------------
	if Aisa25wDllOpen() = False then
	begin
		ErrorMessage(AISA25_SLOT_AUTO);
		Exit;			// aisa25.dll ̃[hɎs܂
	end;

	//----------------------------------------------
	//	o[Wԍ\
	//	aISA-A25 DLL,Driver̃o[Wԍ擾
	//----------------------------------------------
	if Aisa25wGetVersion(@dwDLLVer, @dwDrvVer) = False then
	begin
		ErrorMessage(AISA25_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Driver Version: %08xH',
						[dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

	//----------------------------------------------
	//	aISA-A25̎gp錾
	//----------------------------------------------
	wLogSlot := AISA25_SLOT_AUTO;		// gp̃foCXT܂B
	hWnd		:= 0;
	InitArg := 0;
	bResult := Aisa25wCreate(@wLogSlot,	// ꍇA̎̃foCXi[܂B
							hWnd,							// EBhEnhȂ̂NULLZbg܂B
																// EBhEnhZbg΁A
																// e탁bZ[W܂B
							$6401,						// 3ԖڂɃZbgẮAbZ[WID̊
																// ƂȂlłBۂ̃bZ[WID͂̊lɃI
																// tZbg(WM_EOCȂ)̂ƂȂ܂B
							InitArg);

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA25_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-A25 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

	//----------------------------------------------
	//	\[X擾
	//----------------------------------------------
	if Aisa25wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	//----------------------------------------------
	//	䂷{[h擾
	//----------------------------------------------
	if Aisa25wGetNumBoard(wLogSlot, @wNumBoard) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	//----------------------------------------------
	//	BSN ̒l擾
	//----------------------------------------------
	if Aisa25wGetSwitchValue(wLogSlot, @dwSwitchValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
									 'IO Base Address: %04xH-%04xH'#10 +
									 'IRQ: %2d'#10 +
									 'Num Board: %2d'#10 +
									 'BSN: %02xh',
										 [szA25, ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1,
											ri.dwIRQRegisters[1],
											wNumBoard,
											dwSwitchValue]);

	ResultMessage(strbuf);

	// _Xbgf[^ZbgĕԂ܂B
	pwLogSlot := wLogSlot;

	Result := True;
end;

//--------------------------------------------------------------------------
//	I
//--------------------------------------------------------------------------
function TForm1.EndProc(wLogSlot: Word): Boolean;
begin
	Result := False;

	//----------------------------------------------
	//	aISA-A25 ̎gpJ
	//----------------------------------------------
	if Aisa25wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-A25 Closed');

	//----------------------------------------------
	//	aisa25.dll ̎gpJ
	//----------------------------------------------
	if Aisa25wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa25.dll ̃A[hɎs܂B
	end;

	Result := True;
end;

//--------------------------------------------------------------------------
//	A/D 
//--------------------------------------------------------------------------
function TForm1.AdProc(wLogSlot: Word): Boolean;
var
	strbuf:			String;					// ƃobt@
	che:        array [1..AISA25_AD_CH_ADDR_MAX]
              of TAISA25ADCHE;// CH Gg RAM
	dwChCount:	DWord;					// CH Gg
	mode:				TAISA25ADMODE;	// TvO샂[h
	dwNumData:	DWord;					// TvOf[^
	dwStatus:		DWord;					// TvOXe[^X
	pwData:     PWord;					// TvOf[^
  pwCurPos:   PWord;
	wChCur:			Word;						// `lCNg
	wChFirst:		Word;
	wChLast:		Word;
	i:					DWord;

begin
	Result := False;

	//----------------------------------------------
	//	A/D Ro[^̃Lu[V
	//----------------------------------------------
	if Aisa25wAdc(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('A/D Ro[^Lu[V');

	//----------------------------------------------
	//	A/D CH Gg RAM ̓e擾
	//----------------------------------------------
	dwChCount := AISA25_AD_CH_ADDR_MAX;		// CH Gg

	if Aisa25wAdGetChEntry(wLogSlot, dwChCount, @che) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := 'A/D CH Gg RAM ̓e擾'#10;

	for i := 1 to dwChCount do
	begin
		strbuf := strbuf + Format('Addr:%02xh	 CH:%02d	SdBu:%d	 Gain:%2d'#10,
												[i - 1,
												 che[i].dwChAnalog + 1,
												 che[i].dwSdBu,
												 che[i].dwGain]);
	end;

	ResultMessage(strbuf);

	//----------------------------------------------
	//	A/D CH Gg RAM ̓o^
	//----------------------------------------------
	for i := 1 to dwChCount do
	begin
		che[i].dwGain := AISA25_AD_GAIN_50;		// QCύX
	end;

	if Aisa25wAdSetChEntry(wLogSlot, dwChCount, @che) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('A/D CH Gg RAM ̓eo^');

	//----------------------------------------------
	//	A/D TvO샂[hݒ
	//----------------------------------------------
	mode.dwMode				 := AISA25_AD_MODE_01;		// 샂[h
	mode.dwChAddrFirst := AISA25_AD_CH_0H;			// TvOJn`lAhX
	mode.dwChAddrLast	 := AISA25_AD_CH_FH;			// TvOI`lAhX
	mode.dwSelCnvRate	 := AISA25_AD_RATE_HIGH;	// ϊx
	mode.dwSelClock		 := AISA25_AD_CLOCK_10M;	// TvONbN
	mode.dwTimer			 := 100;									// TvO^C}
	mode.dwCount			 := 50;										// TvO񐔂ݒ
	mode.dwBuffer			 := 50;										// obt@TCY
	mode.dwScn				 := 0;										// e{[h EAB XLԍ(SCN)
																							// }X^{[hɃ^[Qbg{[h
																							// ڑĂꍇ́ASCN ݒ
																							// ĂB

	if Aisa25wAdSetMode(wLogSlot, @mode) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

  ResultMessage('A/D TvO샂[hݒ');

	//----------------------------------------------
	//	A/D TvO̊Jn
	//----------------------------------------------
	if Aisa25wAdStartSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('A/D TvOJn');

	//----------------------------------------------
	//	A/D TvO̒~
	//----------------------------------------------
	if Aisa25wAdStopSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('A/D TvO~');

	//----------------------------------------------
	//	A/D TvȌԂ擾
	//----------------------------------------------
	if Aisa25wAdGetSamplingStatus(wLogSlot, @dwNumData, @dwStatus) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('A/D TvOEXe[^X擾'#10 +
									 'f[^=%d'#10 +
									 'Xe[^X=%d',
									 [dwNumData, dwStatus]);

	ResultMessage(strbuf);


	// TvOf[^Ƃ
	if dwNumData = 0 then
	begin
		Result := True;
		Exit;
	end;

	//----------------------------------------------
	//	A/D TvOf[^̎擾
	//----------------------------------------------
  pwData   := AllocMem(dwNumData * sizeof(Word));
  pwCurPos := pwData;

	if Aisa25wAdGetData(wLogSlot, @dwNumData, pwData) = False then
	begin
		ErrorMessage(wLogSlot);

  	FreeMem(pwData);

		Exit;
	end;

	wChCur	 := Word(mode.dwChAddrFirst);	// Jn`lAhX
	wChFirst := Word(mode.dwChAddrFirst);	// Jn`lAhX
	wChLast  := Word(mode.dwChAddrLast);	// I`lAhX

	strbuf := 'A/D TvOf[^擾'#10;

	for i := 1 to dwNumData do
	begin
		strbuf := strbuf + Format('Addr:%02xh CH%02d:%04xh	',
															[wChCur,
															 che[wChCur + 1].dwChAnalog + 1,
															 pwCurPos^]);
    Inc(pwCurPos);

		if i mod 4 = 0 then	// 4 Ŋ؂
			strbuf := strbuf + #10;

		// ̎QƃAhX
		wChCur := AdProcGetNextChAddr(wChFirst, wChLast, wChCur);
	end;

	FreeMem(pwData);

	ResultMessage(strbuf);

	Result := True;
end;

//--------------------------------------------------------------------------
//	D/A 
//--------------------------------------------------------------------------
function TForm1.DaProc(wLogSlot: Word): Boolean;
var
	strbuf:			 String;				// ƃobt@
	dwSelClock:	 DWord;					// TvONbN
	dwTimer:		 DWord;					// TvO^C}
	dwDaMode:		 DWord;					// D/A [h
	dwDataCount: DWord;					// D/A f[^o^
	pwDataEntry: PWord;					// D/A TvOf[^
	wDaData:		 Word;					// D/A f[^

begin
	Result := False;


	//----------------------------------------------
	//	D/A TvOx̐ݒ
	//----------------------------------------------
	dwSelClock := AISA25_DA_CLOCK_10M;	// 10MHz
	dwTimer		 := 1000;

	if Aisa25wDaSetRateSampling(wLogSlot, dwSelClock, dwTimer) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('D/A TvONbNݒ');

	//----------------------------------------------
	//	D/A g`f[^̓o^
	//----------------------------------------------
	dwDaMode := AISA25_DA_MODE_ALL;		// ALL [hŃf[^o^

																		// g`f[^쐬
	DaProcMakeSineData(@dwDataCount, pwDataEntry);

	if Aisa25wDaSetDataEntry(wLogSlot, dwDaMode, dwDataCount, pwDataEntry) = False then
	begin
		ErrorMessage(wLogSlot);

    FreeMem(pwDataEntry);

		Exit;
	end;

  FreeMem(pwDataEntry);

	ResultMessage('D/A g`f[^o^');

	//----------------------------------------------
	//	D/A TvOJn
	//----------------------------------------------
	dwDaMode := AISA25_DA_MODE_ALL;		// ALL [hŃTvO܂B

	if Aisa25wDaStartSampling(wLogSlot, dwDaMode) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('D/A TvOJn');

	//----------------------------------------------
	//	D/A TvO~
	//----------------------------------------------
	if Aisa25wDaStopSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('D/A TvO~');

	//----------------------------------------------
	//	D/A f[^𒼐ڏo
	//----------------------------------------------
	wDaData := $8000;

	if Aisa25wDaSetData(wLogSlot, wDaData) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('D/A f[^o'#10 +
						 'Data: %08xh',
						 [wDaData]);

	ResultMessage(strbuf);

	Result := True;
end;

//--------------------------------------------------------------------------
//	PIO 
//--------------------------------------------------------------------------
function TForm1.PioProc(wLogSlot: Word): Boolean;
var
	strbuf:	 String;		// ƃobt@
	dwEIn1:	 DWord;			// ėp
	dwEIn2:	 DWord;
	dwEIn3:	 DWord;
	dwEOut1: DWord;			// ėpo
	dwEOut2: DWord;
	dwEOut3: DWord;

begin
	Result := False;

	//----------------------------------------------
	//	ėpo͂ǂݍ
	//----------------------------------------------
	if Aisa25wGetEIn(wLogSlot, @dwEIn1, @dwEIn2, @dwEIn3) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('ėp͂̓e'#10 +
									 'EIn1: %xh'#10 +
									 'EIn2: %xh'#10 +
									 'EIn3: %xh',
									 [dwEIn1, dwEIn2, dwEIn3]);

	ResultMessage(strbuf);

	//----------------------------------------------
	//	ėpo͂֏o
	//----------------------------------------------
	dwEOut1 := AISA25_EIO_ON;
	dwEOut2 := AISA25_EIO_OFF;
	dwEOut3 := AISA25_EIO_ON;

	if Aisa25wSetEOut(wLogSlot, dwEOut1, dwEOut2, dwEOut3) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('ėpo͂̓e'#10 +
									 'EOut1: %xh'#10 +
									 'EOut2: %xh'#10 +
									 'EOut3: %xh',
									 [dwEOut1, dwEOut2, dwEOut3]);

	ResultMessage(strbuf);

	Result := True;
end;

//--------------------------------------------------------------------------
// `lCNgTvO̎̎QƃAhX
//--------------------------------------------------------------------------
function TForm1.AdProcGetNextChAddr(wFirst: Word; wLast: Word; wCur: Word): Word;
begin
	// Jn`lAhXƏI`lAhX
	// ȂCNgȂ
	Result := wCur;

	if wFirst = wLast then Exit;

	wCur := wCur + 1;

	// ŏIAhX𒴂A擪AhXԂ
	Result := AISA25_AD_CH_ADDR_FIRST;

	if AISA25_AD_CH_ADDR_LAST < wCur then Exit;

	// JnAhXIAhX傫A
	// JnAhXCNgl傫ꍇ
	Result := wCur;

	if (wFirst > wLast) and (wCur > wFirst) then Exit;

	// IAhX傫ꍇ
	Result := AISA25_AD_CH_ADDR_FIRST;

	if wLast < wCur then Exit;

	Result := wCur;
end;

//--------------------------------------------------------------------------
//	TCgf[^̍쐬
//		-10V -> +10V -> +10V
//--------------------------------------------------------------------------
procedure TForm1.DaProcMakeSineData(pdwDataCount: PDWord; var pwData: PWord);
var
	dwDataCount: DWord;
	dwData:			 DWord;
	wData:			 Word;
	wWork:			 Word;
  pwCurPos:    PWord;
begin
	dwDataCount := 360;

  pwData   := AllocMem(dwDataCount * sizeof(Word));
  pwCurPos := pwData;

	for dwData := 1 to dwDataCount do
	begin
		wData := Word( Round(($7fff * Sin((dwData - 1) / 180.0 * 3.14159)) + $8000));

		wWork := not wData;
		wWork := wWork and $8000;
		wData := wData and $7FFF;
		wData := wData or wWork;

		pwCurPos^ := wData;
    Inc(pwCurPos);
	end;

	pdwDataCount^ := dwDataCount;
end;

//--------------------------------------------------------------------------
//	ʂ\
//--------------------------------------------------------------------------
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

//--------------------------------------------------------------------------
//	G[bZ[W\
//--------------------------------------------------------------------------
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa25wGetLastError(wLogSlot);

	case dwRes of
		AISA25_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-A25 error'#10#10'Error code: %d',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
