{***************************************************************************}
{	aisa25w.pas																																}
{																																						}
{	aISA-A25																															}
{																																						}
{	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.																		}
{																																						}
{	Date 1999/03/10																														}
{																																						}
{***************************************************************************}

unit aisa25w;

interface

uses
	Windows;


{-----------------------------------------------------------}
{ Miscellaneous																							}
{-----------------------------------------------------------}
const
	AISA25_MAX_SLOTS = 8;						{ Maximum number of slots }
																	{ (Master Board)					}

	AISA25_SLOT_AUTO = Word(not 0); { default search }

{-----------------------------------------------------------}
{	Device ID																									}
{-----------------------------------------------------------}
const
	AISA25_VENDOR_ID = $8B04;
	AISA25_DEVICE_ID = $2541;

function Aisa25GetDeviceID(lParam: LPARAM): Word;

{-----------------------------------------------------------}
{	Board Select																							}
{-----------------------------------------------------------}
const
	AISA25_EAB_BOARD_MAX	=	9;	{ P_XbgŊǗ }
															{ Ƃł{[h̐ }
	AISA25_EAB_MASTER			=	0;	{ }X^{[hI }
	AISA25_EAB_TARGET_0		= 1;	{ PԖڂ̃^[Qbg{[hI }
	AISA25_EAB_TARGET_1		=	2;	{ Q			V										 }
	AISA25_EAB_TARGET_2		=	3;	{ R			V										 }
	AISA25_EAB_TARGET_3		=	4;	{ S			V										 }
	AISA25_EAB_TARGET_4		=	5;	{ T			V										 }
	AISA25_EAB_TARGET_5		=	6;	{ U			V										 }
	AISA25_EAB_TARGET_6		=	7;	{ V			V										 }
	AISA25_EAB_TARGET_7		=	8;	{ W			V										 }

{-----------------------------------------------------------}
{ ėpo͂̒l																						}
{-----------------------------------------------------------}
const
	AISA25_EIO_OFF	= 0;
	AISA25_EIO_ON		= DWord(not 0);


{-----------------------------------------------------------}
{ Error codes																								}
{-----------------------------------------------------------}
const
	AISA25_ERR_SYSTEM						 = 5000; { Windows  GetLastError() R[ĂB}
																			 { ̃tH_ɃhCoȂ\܂B}
	AISA25_ERR_NO_DEVICE				 = 5001; { gp\ȃfoCX܂B}
	AISA25_ERR_IN_USED					 = 5002; { w̃foCX͎gpłB}
	AISA25_ERR_INVALID_ARGUMENT	 = 5003; { Invalid Argument(s) }
	AISA25_ERR_INVALID_SLOT			 = 5004; { Ș_XbgłB}
	AISA25_ERR_INVALID_SEL_BOARD = 5005; { ȃ{[hI܂B}
	AISA25_ERR_NOT_CREATED			 = 5006; { foCXNGCgĂ܂B}
	AISA25_ERR_AIF							 = 5007; { AiO I/F G[܂B}
	AISA25_ERR_TIMEOUT					 = 5008; { ^CAEg܂B}
	AISA25_ERR_NUMDATA					 = 5009; { w肳ꂽ̃f[^obt@ɑ݂܂B}
	AISA25_ERR_NOT_ENOUGH_MEM		 = 5010; { \ȃmۏo܂łB}
	AISA25_ERR_AD_CH_ENTRY_COUNT = 5011; { A/D CH Gg̐ݒ肪słB}
	AISA25_ERR_AD_CH_ANALOG			 = 5012; { A/D CH AiO̓`l̐ݒ肪słB}
	AISA25_ERR_AD_CH_SDBU				 = 5013; { A/D CH oC|[-j|[AVOGh-fBt@V }
																			 { ̐ݒ肪słB}
	AISA25_ERR_AD_CH_GAIN				 = 5014; { A/D CH QC̐ݒ肪słB}
	AISA25_ERR_AD_MODE					 = 5015; { A/D TvO[h̐ݒ肪słB}
	AISA25_ERR_AD_CH_ADDR				 = 5016; { A/D TvO`lAhX̐ݒ肪słB}
	AISA25_ERR_AD_SAMPLING_RATE	 = 5017; { A/D TvOx̐ݒ肪słB}
	AISA25_ERR_AD_SAMPLING_COUNT = 5018; { A/D TvO񐔂̐ݒ肪słB}
	AISA25_ERR_AD_BUFF					 = 5019; { A/D TvOobt@̐ݒ肪słB}
	AISA25_ERR_AD_SCN						 = 5020; { A/D XLԍ̐ݒ肪słB}
	AISA25_ERR_AD_TRG_MODE			 = 5021; { A/D xgK[h̐ݒ肪słB}
	AISA25_ERR_AD_TRG_DAC				 = 5022; { A/D xgK DAC lsłB}
	AISA25_ERR_AD_TRG_EVENT			 = 5023; { A/D xgKCxg񐔂̐ݒ肪słB}
	AISA25_ERR_NOT_EAB					 = 5024; { EAB @\͎gpł܂B}
	AISA25_ERR_EAB_SCN_ADDR			 = 5025; { EAB SCN AhX̐ݒ肪słB}
	AISA25_ERR_EAB_SCN_COUNT		 = 5026; { EAB SCN o^̐ݒ肪słB}
	AISA25_ERR_EAB_SCN					 = 5027; { EAB SCN ̐ݒ肪słB}
	AISA25_ERR_AD_START					 = 5028; { A/D TvOJnł܂BAdSetMode sĂ }
																			 { B}
	AISA25_ERR_AD_BUSY					 = 5029; { A/D Rg[ғłB}
	AISA25_ERR_AD_BUFF_NOT_EMPTY = 5030; { A/D hCoobt@Ƀf[^cĂ܂BAdGetData ܂ }
																			 { AdSetMode sĂB}
	AISA25_ERR_AD_SYNC_START		 = 5031; { A/D TvȌꍇA^[QbgJnł܂B}
	AISA25_ERR_AD_SYNC_STOP			 = 5032; { A/D TvȌꍇA^[Qbg~ł܂B}
	AISA25_ERR_AD_SYNC_SCN			 = 5033; { A/D TvOAVOTvȌꍇAXL }
																			 { ԍ(SCN)𓝈ꂵĂB}
	AISA25_ERR_AD_SYNC_CNV_RATE	 = 5034; { A/D TvO̕ϊxA܂̓}X^̃^C} }
																			 { ݒlsłB}
	AISA25_ERR_AD_SYNC_BUFF			 = 5035; { A/D TvȌꍇA}X^ƃ^[Qbg̃obt@TCY }
																			 { 𓝈ꂵĂB}
	AISA25_ERR_DA_MODE					 = 5036; { D/A [h̐ݒ肪słB}
	AISA25_ERR_DA_SAMPLING_RATE	 = 5037; { D/A TvOx̐ݒ肪słB}
	AISA25_ERR_DA_ENTRY_COUNT		 = 5038; { D/A TvOf[^słB}
	AISA25_ERR_DA_BUSY					 = 5039; { D/A Rg[ғłB}
	AISA25_ERR_DA_ENTRY_DATA		 = 5040; { D/A TvOf[^o^Ă܂B}

	AISA25_ERR_INTERNAL					 = 5100; { Send mail to us }
	AISA25_ERR_UNKNOWN					 = 5101; { Help me! }
	AISA25_SUCCESS							 =		0; { Successfully proccessed }


{-----------------------------------------------------------}
{ Resource information structure
{-----------------------------------------------------------}
const
	AISA25_MAX_MEM	=	 9;		{ number of memory windows }
	AISA25_MAX_IO		= 20;		{ number of i/o windows }
	AISA25_MAX_IRQ	=	 7;		{ number of irqs }
	AISA25_MAX_DMA	=	 7;		{ number of dmas }

type
	TAISA25RESOURCE = record
		dwNumMemWindows: DWord;																{ Not used }
		dwMemBase:			 array [1..AISA25_MAX_MEM] of DWord;	{ Not used }
		dwMemLength:		 array [1..AISA25_MAX_MEM] of DWord;	{ Not used }
		dwMemAttrib:		 array [1..AISA25_MAX_MEM] of DWord;	{ Not used }
		dwNumIOPorts:		 DWord;																{ Num IO ports }
		dwIOPortBase:		 array [1..AISA25_MAX_IO]	 of DWord;	{ I/O port base }
		dwIOPortLength:	 array [1..AISA25_MAX_IO]	 of DWord;	{ I/O port length }
		dwNumIRQs:			 DWord;																{ Num IRQ info }
		dwIRQRegisters:	 array [1..AISA25_MAX_IRQ] of DWord;	{ IRQ list }
		dwIRQAttrib:		 array [1..AISA25_MAX_IRQ] of DWord;	{ IRQ Attrib list }
		dwNumDMAs:			 DWord;																{ Not used }
		dwDMALst:				 array [1..AISA25_MAX_DMA] of DWord;	{ Not used }
		dwDMAAttrib:		 array [1..AISA25_MAX_DMA] of DWord;	{ Not used }
		dwReserved1:		 array [1..3] of DWord;								{ Not used }
	end;

	PAISA25R = ^TAISA25RESOURCE;

{-----------------------------------------------------------}
{ Channel Entry Data structure															}
{-----------------------------------------------------------}

{ ݒ`l̃AhX }
const
	AISA25_AD_CH_ADDR_MAX		= 16;

	AISA25_AD_CH_ADDR_FIRST	= $00;
	AISA25_AD_CH_0H					= $00;
	AISA25_AD_CH_1H					= $01;
	AISA25_AD_CH_2H					= $02;
	AISA25_AD_CH_3H					= $03;
	AISA25_AD_CH_4H					= $04;
	AISA25_AD_CH_5H					= $05;
	AISA25_AD_CH_6H					= $06;
	AISA25_AD_CH_7H					= $07;
	AISA25_AD_CH_8H					= $08;
	AISA25_AD_CH_9H					= $09;
	AISA25_AD_CH_AH					= $0A;
	AISA25_AD_CH_BH					= $0B;
	AISA25_AD_CH_CH					= $0C;
	AISA25_AD_CH_DH					= $0D;
	AISA25_AD_CH_EH					= $0E;
	AISA25_AD_CH_FH					= $0F;
	AISA25_AD_CH_ADDR_LAST	= $0F;

{ ̓`l̐ݒl }
const
	AISA25_AD_CH_MAX		= 16;

	AISA25_AD_CH_FIRST	= 0;
	AISA25_AD_CH_01			= 0;
	AISA25_AD_CH_02			= 1;
	AISA25_AD_CH_03			= 2;
	AISA25_AD_CH_04			= 3;
	AISA25_AD_CH_05			= 4;
	AISA25_AD_CH_06			= 5;
	AISA25_AD_CH_07			= 6;
	AISA25_AD_CH_08			= 7;
	AISA25_AD_CH_09			= 8;
	AISA25_AD_CH_10			= 9;
	AISA25_AD_CH_11			= 10;
	AISA25_AD_CH_12			= 11;
	AISA25_AD_CH_13			= 12;
	AISA25_AD_CH_14			= 13;
	AISA25_AD_CH_15			= 14;
	AISA25_AD_CH_16			= 15;
	AISA25_AD_CH_LAST_D = 7;	{ fBt@V͎̍ŏIl }
	AISA25_AD_CH_LAST_S = 15;	{ VOGh͎̍ŏIl }

								 { dwSdBu b SingleEnd/Differentialb Bipolar-Unipolar }
const						 { --------------------------------------------------- }
	AISA25_AD_SDBU_0 = 0;	{ b			 SingleEnd			 b		 Bipolar			 }
	AISA25_AD_SDBU_1 = 1;	{ b			 SingleEnd			 b		 Unipolar			 }
	AISA25_AD_SDBU_2 = 2;	{ b			Differential		 b		 Bipolar			 }
	AISA25_AD_SDBU_3 = 3;	{ b			Differential		 b		 Unipolar			 }

										{ dwGainb Gain b Bipolar b Unipolar
const								{ ------------------------------------------}
	AISA25_AD_GAIN_01 = 1;	{ b 1 { b }10V	 b 0`+10V				}
	AISA25_AD_GAIN_05 = 5;	{ b 5 { b }2V		 b 0`+2V				}
	AISA25_AD_GAIN_10 = 10;	{ b 10{ b }1V		 b 0`+1V				}
	AISA25_AD_GAIN_50 = 50;	{ b 50{ b }200mV b 0`+200mV			}

type
	TAISA25ADCHE = record
		dwChAnalog: DWord;		{ AiO̓`lw }
		dwSdBu:			DWord;		{ VOGh-ft@VAoC|[-j|[̎w }
		dwGain:			DWord;		{ 1{A5{A10{A50{̒w }
	end;

	PAISA25ADCHE = ^TAISA25ADCHE;

{-----------------------------------------------------------}
{ Sampling definition																				}
{-----------------------------------------------------------}

{ TvO[h }
									{ dwAdModeb	-ĕ@	 bݸމ񐔁bb		荞				b}
const							{ -------------------------------------	 ---------------------	}
	AISA25_AD_MODE_00 = 0;	{ b		 		 b			1			 bb				EOC					b}
	AISA25_AD_MODE_01 = 1;	{ b		 		 b	 1`65536	 bb		 ݸEND		b}
	AISA25_AD_MODE_02 = 2;	{ b ض b	 1`65536	 bb		 ݸEND		b}
	AISA25_AD_MODE_03 = 3;	{ b Oض b	 1`65536	 bb		 ݸEND		b}
	AISA25_AD_MODE_04 = 4;	{ b		 		 b					 bbFIFO HALF,FULL,OVRFb}
	AISA25_AD_MODE_05 = 5;	{ b	 Oض	 b			1			 bb				EOC					b}
	AISA25_AD_MODE_06 = 6;	{ b ߽ضށb	 1`65536	 bb		 ݸEND		b}
	AISA25_AD_MODE_07 = 7;	{ b O߽ضށb	 1`65536	 bb		 ݸEND		b}
	AISA25_AD_MODE_08 = 8;	{ b ϽްނbϽްނ̐݁bb	 Ͻްނ̐ݒ		b}
													{ b		 bɂ		 bb			 ɂ				b}

						{ dwSelCnvRate		 bϊx							}
const				{ --------------------------------------- }
	AISA25_AD_RATE_LOW	= 0;	 { b20us									}
	AISA25_AD_RATE_HIGH = 1;	 { b10us									}

							{ dwSelClock		 bNbN							 }
const					{ ---------------------------------------}
	AISA25_AD_CLOCK_100K = 0;	 { b100KHz								 }
	AISA25_AD_CLOCK_10M	 = 1;	 { b 10MHz								 }
	AISA25_AD_CLOCK_EXT	 = 2;	 { b O								 }

const
	AISA25_AD_TIME_MIN_CL100K = 1;		{ NbN 100KHz I̍ŏl }
	AISA25_AD_TIME_MIN_CL10M	= 100;	{ NbN 10MHz I̍ŏl	 }
																		{ ̃NbNŏĺAϊx HIGH ɂꍇ̒l }
																		{ ϊx LOW ɂꍇ́AŏlQ{ɂȂ܂B }
	AISA25_AD_TIME_MIN_CLEXT	= 1;		{ ONbNI̍ŏl }
	AISA25_AD_TIME_MAX				= 65536;

const
	AISA25_AD_COUNT_MIN				= 1;			{ TvO񐔂̍ŏl }
	AISA25_AD_COUNT_MAX				= 65536;	{ TvO񐔂̍ől }

const
	AISA25_AD_BUFF_MIN				= 1;			{ obt@TCY̍ŏl }

				{				 dwTrgMode	bxgK[h					bdwTrgLvl1bdwTrgLvl2b	 }
const		{				 --------------------------------------------------------------------}
	AISA25_AD_LVLTRG_0 = 0;	{ bGbWgK			b		 		b				b	 }
	AISA25_AD_LVLTRG_1 = 1;	{ bオGbWgK			b		 		b				b	 }
	AISA25_AD_LVLTRG_2 = 2;	{ bCEChgK(͈͓)	b		 		b			b	 }
	AISA25_AD_LVLTRG_3 = 3;	{ bAEgEChgK(͈͊O)b		 		b			b	 }
	AISA25_AD_LVLTRG_4 = 4;	{ b}CiXX[vgK			b		 		b			b	 }
	AISA25_AD_LVLTRG_5 = 5;	{ bvXX[vgK				b		 		b			b	 }

const
	AISA25_AD_LVLTRG_DAC			= $FF;			{ AiO͐MK }

const
	AISA25_AD_LVLTRG_EVENT_MIN = 0;				{ gK̍ŏl }
	AISA25_AD_LVLTRG_EVENT_MAX = 65536;		{ gK̍ől }

const
	AISA25_AD_EAB_SCN_FIRST		= $00;			{ EAB Scan Number First }
	AISA25_AD_EAB_SCN_0				= $00;			{			V		 0					}
	AISA25_AD_EAB_SCN_1				= $01;			{			V		 1					}
	AISA25_AD_EAB_SCN_2				= $02;			{			V		 2					}
	AISA25_AD_EAB_SCN_3				= $03;			{			V		 3					}
	AISA25_AD_EAB_SCN_4				= $04;			{			V		 4					}
	AISA25_AD_EAB_SCN_5				= $05;			{			V		 5					}
	AISA25_AD_EAB_SCN_6				= $06;			{			V		 6					}
	AISA25_AD_EAB_SCN_7				= $07;			{			V		 7					}
	AISA25_AD_EAB_SCN_LAST		= $07;			{			V		 Last				}

type
	TAISA25ADMODE = record
		dwMode:				 DWord;	{ 샂[h }
		dwChAddrFirst: DWord;	{ TvOJn`lAhX(0-15) }
		dwChAddrLast:	 DWord;	{ TvOI`lAhX(0-15) }
		dwSelCnvRate:	 DWord;	{ ϊx }
		dwSelClock:		 DWord;	{ TvONbN }
		dwTimer:			 DWord;	{ TvO^C}(1-65536) }
		dwCount:			 DWord;	{ TvO񐔂ݒ(1-65536) }
		dwBuffer:			 DWord;	{ obt@TCYAIɊmۂłlől }
		dwTrgMode:		 DWord;	{ xgK[hݒ }
		dwTrgLvl1:		 DWord;	{ xgKDACl1̐ݒ(00`FFh ͓dWɂ܂) }
													{ dwTrgLvl1 > dwTrgLvl2 }
		dwTrgLvl2:		 DWord;	{ xgKDACl2̐ݒ(00`FFh ͓dWɂ܂) }
		dwTrgEvent:		 DWord;	{ Cxg(0-65536) }
		dwScn:				 DWord;	{ e{[h EAB XLԍ(SCN) }
	end;

	PAISA25ADM = ^TAISA25ADMODE;

{ SCN ݒ̃AhX }
const
	AISA25_AD_SCN_ADDR_MAX	 = 16;

	AISA25_AD_SCN_ADDR_FIRST = $00;
	AISA25_AD_SCN_0H				 = $00;
	AISA25_AD_SCN_1H				 = $01;
	AISA25_AD_SCN_2H				 = $02;
	AISA25_AD_SCN_3H				 = $03;
	AISA25_AD_SCN_4H				 = $04;
	AISA25_AD_SCN_5H				 = $05;
	AISA25_AD_SCN_6H				 = $06;
	AISA25_AD_SCN_7H				 = $07;
	AISA25_AD_SCN_8H				 = $08;
	AISA25_AD_SCN_9H				 = $09;
	AISA25_AD_SCN_AH				 = $0A;
	AISA25_AD_SCN_BH				 = $0B;
	AISA25_AD_SCN_CH				 = $0C;
	AISA25_AD_SCN_DH				 = $0D;
	AISA25_AD_SCN_EH				 = $0E;
	AISA25_AD_SCN_FH				 = $0F;
	AISA25_AD_SCN_ADDR_LAST	 = $0F;

type
	TAISA25ADEAB = record
		dwScnAddrFirst: DWord;																			{ EAB Jn SCN Gg RAM AhX }
		dwScnAddrLast:	DWord;																			{ EAB I SCN Gg RAM AhX }
		dwScnCount:			DWord;																			{ EAB SCN Gg RAM ւ̓o^f[^ }
		dwScnEntry:			array [1..AISA25_AD_SCN_ADDR_MAX] of DWord;	{ EAB SCN Gg RAM ւ̓o^f[^ }
	end;

	PAISA25ADE = ^TAISA25ADEAB;

{ TvOXe[^X }
const
	AISA25_STS_SAMPLING					= $01;
	AISA25_STS_EOC							= $02;
	AISA25_STS_SAMPLING_END			= $04;
	AISA25_STS_BUFF_HALF_FULL		= $08;
	AISA25_STS_BUFF_FULL				= $10;
	AISA25_STS_BUFF_OVERFLOW		= $20;
	AISA25_STS_SAMPLING_OVERRUN = $40;
	AISA25_STS_FIFO_EXIST				= $80;	{ FIFO obt@Ƀf[^݂ }

{ Aisa25Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ }
{ ItZbglbZ[Wo܂B}
{$IFNDEF WM_EOC}
const
	WM_EOC							= 0;
	WM_SAMPLING_END			= 1;
	WM_BUFF_HALF_FULL		= 2;
	WM_BUFF_FULL				= 3;
	WM_BUFF_OVERFLOW		= 4;
	WM_SAMPLING_OVERRUN = 5;
{$ENDIF}	{ WM_EOC }

{ bZ[W wParam  wLogSlot ̒l擾 }
function Aisa25GetLogSlot(wParam: WPARAM): Word;
{ bZ[W wParam  wSelBoard ̒l擾 }
function Aisa25GetSelBoard(wParam: WPARAM): Word;

{-----------------------------------------------------------}
{ DA TvO^C}̃NbN														}
{-----------------------------------------------------------}
							{ dwSelClock		bNbN							}
const					{ --------------------------------------}
	AISA25_DA_CLOCK_100K = 0; { b100KHz								}
	AISA25_DA_CLOCK_10M	 = 1; { b 10MHz								}

const
	AISA25_DA_TIME_MIN_CL10M	= 100;	{ NbN 10MHz I̍ŏl	 }
	AISA25_DA_TIME_MIN_CL100K = 1;		{ NbN 100KHz I̍ŏl }
	AISA25_DA_TIME_MAX				= 65536;

const
	AISA25_DA_DATA_ALL_MAX		= 32768;
	AISA25_DA_DATA_BANK_MAX		= 4096;

const
	AISA25_DA_BANK_MAX				= 8;		{ D/A oN̍ő吔 }

const
	AISA25_DA_MODE_ALL		= DWord(not 0);
	AISA25_DA_MODE_BANK_0 = 0;
	AISA25_DA_MODE_BANK_1 = 1;
	AISA25_DA_MODE_BANK_2 = 2;
	AISA25_DA_MODE_BANK_3 = 3;
	AISA25_DA_MODE_BANK_4 = 4;
	AISA25_DA_MODE_BANK_5 = 5;
	AISA25_DA_MODE_BANK_6 = 6;
	AISA25_DA_MODE_BANK_7 = 7;

const
	AISA25_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA25_DLL_NAME = 'aisa25.dll';	{ DLL }


{-----------------------------------------------------------}
{ API Functions																							}
{-----------------------------------------------------------}

function Aisa25wDllOpen: Boolean;		// DLL [h
function Aisa25wDllClose: Boolean;	// DLL A[h

// ʏgp
function Aisa25wGetVersion(pdwDllVer: PDWord; pdwDrvVer: PDWord): Boolean;
function Aisa25wCreate(pwLogSlot: PWord; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
function Aisa25wClose(wLogSlot: Word): Boolean;
function Aisa25wGetResource(wLogSlot: Word; pres: PAISA25R): Boolean;
function Aisa25wGetNumBoard(wLogSlot: Word; pwNumBoard: PWord): Boolean;
function Aisa25wGetSwitchValue(wLogSlot: Word; pdwSwitchValue: PDWord): Boolean;
function Aisa25wReset(wLogSlot: Word): Boolean;

function Aisa25wAdc(wLogSlot: Word): Boolean;
function Aisa25wAdGetChEntry(wLogSlot: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Boolean;
function Aisa25wAdSetChEntry(wLogSlot: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Boolean;
function Aisa25wAdSetMode(wLogSlot: Word; pmode: PAISA25ADM): Boolean;
function Aisa25wAdStartSampling(wLogSlot: Word): Boolean;
function Aisa25wAdStopSampling(wLogSlot: Word): Boolean;
function Aisa25wAdGetSamplingStatus(wLogSlot: Word; pdwNumData: PDWord; pdwStatus: PDWord): Boolean;
function Aisa25wAdGetData(wLogSlot: Word; pdwNumData: PDWord; pwData: PWord): Boolean;

function Aisa25wDaSetRateSampling(wLogSlot: Word; dwSelClock: DWord; dwTimer: DWord): Boolean;
function Aisa25wDaSetDataEntry(wLogSlot: Word; dwDaMode: DWord; dwDataCount: DWord; pwDataEntry: PWord): Boolean;
function Aisa25wDaStartSampling(wLogSlot: Word; dwDaMode: DWord): Boolean;
function Aisa25wDaStopSampling(wLogSlot: Word): Boolean;
function Aisa25wDaSetData(wLogSlot: Word; wDaData: Word): Boolean;

function Aisa25wGetEIn(wLogSlot: Word; pdwEIn1: PDWord; pdwEIn2: PDWord; pdwEIn3: PDWord): Boolean;
function Aisa25wSetEOut(wLogSlot: Word; dwEOut1: DWord; dwEOut2: DWord; dwEOut3: DWord): Boolean;

function Aisa25wGetLastError(wLogSlot: Word): DWord;

// EAB gp
function Aisa25wGetSwitchValueEx(wLogSlot: Word; wSelBoard: Word; pdwSwitchValue: PDWord): Boolean;
function Aisa25wResetEx(wLogSlot: Word; wSelBoard: Word): Boolean;

function Aisa25wAdcEx(wLogSlot: Word; wSelBoard: Word): Boolean;
function Aisa25wAdGetChEntryEx(wLogSlot: Word; wSelBoard: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Boolean;
function Aisa25wAdSetChEntryEx(wLogSlot: Word; wSelBoard: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Boolean;
function Aisa25wAdSetModeEx(wLogSlot: Word; wSelBoard: Word; pmode: PAISA25ADM): Boolean;
function Aisa25wAdSetEab(wLogSlot: Word; peab: PAISA25ADE): Boolean;
function Aisa25wAdStartSamplingEx(wLogSlot: Word; wSelBoard: Word): Boolean;
function Aisa25wAdStopSamplingEx(wLogSlot: Word; wSelBoard: Word): Boolean;
function Aisa25wAdGetSamplingStatusEx(wLogSlot: Word; wSelBoard: Word; pdwNumData: PDWord; pdwStatus: PDWord): Boolean;
function Aisa25wAdGetDataEx(wLogSlot: Word; wSelBoard: Word; pdwNumData: PDWord; pwData: PWord): Boolean;

function Aisa25wDaSetRateSamplingEx(wLogSlot: Word; wSelBoard: Word; dwSelClock: DWord; dwTimer: DWord): Boolean;
function Aisa25wDaSetDataEntryEx(wLogSlot: Word; wSelBoard: Word; dwDaMode: DWord; dwDataCount: DWord; pwDataEntry: PWord): Boolean;
function Aisa25wDaStartSamplingEx(wLogSlot: Word; wSelBoard: Word; dwDaMode: DWord): Boolean;
function Aisa25wDaStopSamplingEx(wLogSlot: Word; wSelBoard: Word): Boolean;
function Aisa25wDaSetDataEx(wLogSlot: Word; wSelBoard: Word; wDaData: Word): Boolean;

function Aisa25wGetEInEx(wLogSlot: Word; wSelBoard: Word; pdwEIn1: PDWord; pdwEIn2: PDWord; pdwEIn3: PDWord): Boolean;
function Aisa25wSetEOutEx(wLogSlot: Word; wSelBoard: Word; dwEOut1: DWord; dwEOut2: DWord; dwEOut3: DWord): Boolean;

implementation

type
{ ʏgp }
	TAisa25GetVersion = function(pdwDllVer: PDWord; pdwDrvVer: PDWord): Bool; stdcall;
	TAisa25Create = function(pwLogSlot: PWord; hWnd: THandle; uWMBase: UInt; var pvInitArg): Bool; stdcall;
	TAisa25Close = function(wLogSlot: Word): Bool; stdcall;
	TAisa25GetResource = function(wLogSlot: Word; pres: PAISA25R): Bool; stdcall;
	TAisa25GetNumBoard = function(wLogSlot: Word; pwNumBoard: PWord): Bool; stdcall;
	TAisa25GetSwitchValue = function(wLogSlot: Word; pdwSwitchValue: PDWord): Bool; stdcall;
	TAisa25Reset = function(wLogSlot: Word): Bool; stdcall;
	TAisa25Adc = function(wLogSlot: Word): Bool; stdcall;
	TAisa25AdGetChEntry = function(wLogSlot: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Bool; stdcall;
	TAisa25AdSetChEntry = function(wLogSlot: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Bool; stdcall;
	TAisa25AdSetMode = function(wLogSlot: Word; pmode: PAISA25ADM): Bool; stdcall;
	TAisa25AdStartSampling = function(wLogSlot: Word): Bool; stdcall;
	TAisa25AdStopSampling = function(wLogSlot: Word): Bool; stdcall;
	TAisa25AdGetSamplingStatus = function(wLogSlot: Word; pdwNumData: PDWord; pdwStatus: PDWord): Bool; stdcall;
	TAisa25AdGetData = function(wLogSlot: Word; pdwNumData: PDWord; pwData: PWord): Bool; stdcall;
	TAisa25DaSetRateSampling = function(wLogSlot: Word; dwSelClock: DWord; dwTimer: DWord): Bool; stdcall;
	TAisa25DaSetDataEntry = function(wLogSlot: Word; dwDaMode: DWord; dwDataCount: DWord; pwDataEntry: PWord): Bool; stdcall;
	TAisa25DaStartSampling = function(wLogSlot: Word; dwDaMode: DWord): Bool; stdcall;
	TAisa25DaStopSampling = function(wLogSlot: Word): Bool; stdcall;
	TAisa25DaSetData = function(wLogSlot: Word; wDaData: Word): Bool; stdcall;
	TAisa25GetEIn = function(wLogSlot: Word; pdwEIn1: PDWord; pdwEIn2: PDWord; pdwEIn3: PDWord): Bool; stdcall;
	TAisa25SetEOut = function(wLogSlot: Word; dwEOut1: DWord; dwEOut2: DWord; dwEOut3: DWord): Bool; stdcall;
	TAisa25GetLastError = function(wLogSlot: Word): DWord; stdcall;

{ EAB gp }
	TAisa25GetSwitchValueEx = function(wLogSlot: Word; wSelBoard: Word; pdwSwitchValue: PDWord): Bool; stdcall;
	TAisa25ResetEx = function(wLogSlot: Word; wSelBoard: Word): Bool; stdcall;
	TAisa25AdcEx = function(wLogSlot: Word; wSelBoard: Word): Bool; stdcall;
	TAisa25AdGetChEntryEx = function(wLogSlot: Word; wSelBoard: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Bool; stdcall;
	TAisa25AdSetChEntryEx = function(wLogSlot: Word; wSelBoard: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Bool; stdcall;
	TAisa25AdSetModeEx = function(wLogSlot: Word; wSelBoard: Word; pmode: PAISA25ADM): Bool; stdcall;
	TAisa25AdSetEab = function(wLogSlot: Word; peab: PAISA25ADE): Bool; stdcall;
	TAisa25AdStartSamplingEx = function(wLogSlot: Word; wSelBoard: Word): Bool; stdcall;
	TAisa25AdStopSamplingEx = function(wLogSlot: Word; wSelBoard: Word): Bool; stdcall;
	TAisa25AdGetSamplingStatusEx = function(wLogSlot: Word; wSelBoard: Word; pdwNumData: PDWord; pdwStatus: PDWord): Bool; stdcall;
	TAisa25AdGetDataEx = function(wLogSlot: Word; wSelBoard: Word; pdwNumData: PDWord; pwData: PWord): Bool; stdcall;
	TAisa25DaSetRateSamplingEx = function(wLogSlot: Word; wSelBoard: Word; dwSelClock: DWord; dwTimer: DWord): Bool; stdcall;
	TAisa25DaSetDataEntryEx = function(wLogSlot: Word; wSelBoard: Word; dwDaMode: DWord; dwDataCount: DWord; pwDataEntry: PWord): Bool; stdcall;
	TAisa25DaStartSamplingEx = function(wLogSlot: Word; wSelBoard: Word; dwDaMode: DWord): Bool; stdcall;
	TAisa25DaStopSamplingEx = function(wLogSlot: Word; wSelBoard: Word): Bool; stdcall;
	TAisa25DaSetDataEx = function(wLogSlot: Word; wSelBoard: Word; wDaData: Word): Bool; stdcall;
	TAisa25GetEInEx = function(wLogSlot: Word; wSelBoard: Word; pdwEIn1: PDWord; pdwEIn2: PDWord; pdwEIn3: PDWord): Bool; stdcall;
	TAisa25SetEOutEx = function(wLogSlot: Word; wSelBoard: Word; dwEOut1: DWord; dwEOut2: DWord; dwEOut3: DWord): Bool; stdcall;

function Aisa25wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa25GetVersion:						TAisa25GetVersion;
	pAisa25Create:								TAisa25Create;
	pAisa25Close:									TAisa25Close;
	pAisa25GetResource:						TAisa25GetResource;
	pAisa25GetNumBoard:						TAisa25GetNumBoard;
	pAisa25GetSwitchValue:				TAisa25GetSwitchValue;
	pAisa25Reset:									TAisa25Reset;
	pAisa25Adc:										TAisa25Adc;
	pAisa25AdGetChEntry:					TAisa25AdGetChEntry;
	pAisa25AdSetChEntry:					TAisa25AdSetChEntry;
	pAisa25AdSetMode:							TAisa25AdSetMode;
	pAisa25AdStartSampling:				TAisa25AdStartSampling;
	pAisa25AdStopSampling:				TAisa25AdStopSampling;
	pAisa25AdGetSamplingStatus:		TAisa25AdGetSamplingStatus;
	pAisa25AdGetData:							TAisa25AdGetData;
	pAisa25DaSetRateSampling:			TAisa25DaSetRateSampling;
	pAisa25DaSetDataEntry:				TAisa25DaSetDataEntry;
	pAisa25DaStartSampling:				TAisa25DaStartSampling;
	pAisa25DaStopSampling:				TAisa25DaStopSampling;
	pAisa25DaSetData:							TAisa25DaSetData;
	pAisa25GetEIn:								TAisa25GetEIn;
	pAisa25SetEOut:								TAisa25SetEOut;
	pAisa25GetLastError:					TAisa25GetLastError;
	pAisa25GetSwitchValueEx:			TAisa25GetSwitchValueEx;
	pAisa25ResetEx:								TAisa25ResetEx;
	pAisa25AdcEx:									TAisa25AdcEx;
	pAisa25AdGetChEntryEx:				TAisa25AdGetChEntryEx;
	pAisa25AdSetChEntryEx:				TAisa25AdSetChEntryEx;
	pAisa25AdSetModeEx:						TAisa25AdSetModeEx;
	pAisa25AdSetEab:							TAisa25AdSetEab;
	pAisa25AdStartSamplingEx:			TAisa25AdStartSamplingEx;
	pAisa25AdStopSamplingEx:			TAisa25AdStopSamplingEx;
	pAisa25AdGetSamplingStatusEx:	TAisa25AdGetSamplingStatusEx;
	pAisa25AdGetDataEx:						TAisa25AdGetDataEx;
	pAisa25DaSetRateSamplingEx:		TAisa25DaSetRateSamplingEx;
	pAisa25DaSetDataEntryEx:			TAisa25DaSetDataEntryEx;
	pAisa25DaStartSamplingEx:			TAisa25DaStartSamplingEx;
	pAisa25DaStopSamplingEx:			TAisa25DaStopSamplingEx;
	pAisa25DaSetDataEx:						TAisa25DaSetDataEx;
	pAisa25GetEInEx:							TAisa25GetEInEx;
	pAisa25SetEOutEx:							TAisa25SetEOutEx;


//****************************************************************************
// 		aisa25.dll[h
// 		
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA25_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa25wGetDllExportFunc = False then
	begin
		Aisa25wDllClose;	{ DLL GNX|[g֐擾ɎŝŁADLL N[Y }
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		aisa25.dllA[h
// 		
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDllClose: Boolean;		// DLL A[h
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// 		aISA-A25 DLL,Driver̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[AhX
//				pdwDrvVer Drivero[Wԍi[AhX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wGetVersion(pdwDllVer: PDWord; pdwDrvVer: PDWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aISA-A25̔Cӂ̃foCX̎gp錾
// 		pwLogSlot gpfoCXi[AhX
//				hWnd		bZ[W𑗂EBhEnh
//				uWMBase	ƂȂ郁bZ[WID
//				pvInitArg NULL ݒ
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wCreate(pwLogSlot: PWord; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
end;

//****************************************************************************
// 		aISA-A25̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot foCX
//				pres		 \[Xi[\̂̃AhX
// ߂l True	
//			False	s
//****************************************************************************
function Aisa25wGetResource(wLogSlot: Word; pres: PAISA25R): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25GetResource(wLogSlot, pres);
end;

//****************************************************************************
// 		}X^{[h܂߂{[h擾
// 		wLogSlot	 foCX
//				pwNumBoard {[h̐i[AhX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wGetNumBoard(wLogSlot: Word; pwNumBoard: PWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25GetNumBoard(wLogSlot, pwNumBoard);
end;

//****************************************************************************
// 		BSN ̒l擾
// 		wLogSlot		 foCX
//				pdwSwitchValue BSN ̒li[AhX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wGetSwitchValue(wLogSlot: Word; pdwSwitchValue: PDWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25GetSwitchValue(wLogSlot, pdwSwitchValue);
end;

//****************************************************************************
// 		aISA-A25 Zbg
// 		wLogSlot foCX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wReset(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25Reset(wLogSlot);
end;

//****************************************************************************
// 		ADC Lu[V
// 		wLogSlot foCX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdc(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25Adc(wLogSlot);
end;

//****************************************************************************
// 		CH Gg RAM ̎擾
// 		wLogSlot	foCX
//				dwChCount `lGgRAM擾`lf[^̐w
//				pEntries	CH Gg RAM ̓ei[̈ւ̃|C^
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdGetChEntry(wLogSlot: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdGetChEntry(wLogSlot, dwChCount, pEntries);
end;

//****************************************************************************
// 		CH Gg RAM ̓o^
// 		wLogSlot	foCX
//				dwChCount `lGgRAMɃGg`lf[^̐w
//				pEntries	CH Gg RAM ̓ei[̈ւ̃|C^
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdSetChEntry(wLogSlot: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdSetChEntry(wLogSlot, dwChCount, pEntries);
end;

//****************************************************************************
// 		A/D TvO샂[hݒ
// 		wLogSlot foCX
//				pmode		 A/D [hݒf[^
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdSetMode(wLogSlot: Word; pmode: PAISA25ADM): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdSetMode(wLogSlot, pmode);
end;

//****************************************************************************
// 		A/D TvOJn
// 		wLogSlot foCX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdStartSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdStartSampling(wLogSlot);
end;

//****************************************************************************
// 		A/D TvO~
// 		wLogSlot foCX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdStopSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdStopSampling(wLogSlot);
end;

//****************************************************************************
// 		A/D TvȌԂ擾
// 		wLogSlot	 foCX
//				pdwNumData TvOς݃f[^i[̈ւ̃AhX
//				pdwStatus	 TvOԂ̃Xe[^Xi[̈ւ̃AhX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdGetSamplingStatus(wLogSlot: Word; pdwNumData: PDWord; pdwStatus: PDWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdGetSamplingStatus(wLogSlot, pdwNumData, pdwStatus);
end;

//****************************************************************************
// 		A/D TvOf[^̎擾
// 		wLogSlot	 foCX
//				pdwNumData 擾f[^(ۂɎ擾f[^)
//				pwData	 f[^obt@ւ̃AhX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdGetData(wLogSlot: Word; pdwNumData: PDWord; pwData: PWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdGetData(wLogSlot, pdwNumData, pwData);
end;

//****************************************************************************
// 		D/A TvOx̐ݒ
// 		wLogSlot	 foCX
//				dwSelClock D/A TvONbNݒ
//				dwTimer	 D/A TvO^Cݒ
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDaSetRateSampling(wLogSlot: Word; dwSelClock: DWord; dwTimer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaSetRateSampling(wLogSlot, dwSelClock, dwTimer);
end;

//****************************************************************************
// 		D/A f[^̓o^
// 		wLogSlot		foCX
//				dwDaMode		D/A TvOf[^o^̑I
//				dwDataCount ރf[^̌
//				pwDataEntry D/A f[^ݒ肷z
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDaSetDataEntry(wLogSlot: Word; dwDaMode: DWord; dwDataCount: DWord; pwDataEntry: PWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaSetDataEntry(wLogSlot, dwDaMode, dwDataCount, pwDataEntry);
end;

//****************************************************************************
// 		D/A TvOJn
// 		wLogSlot foCX
//				dwDaMode D/A TvO[h̑I
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDaStartSampling(wLogSlot: Word; dwDaMode: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaStartSampling(wLogSlot, dwDaMode);
end;

//****************************************************************************
// 		D/A TvO~
// 		wLogSlot foCX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDaStopSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaStopSampling(wLogSlot);
end;

//****************************************************************************
// 		D/A f[^o
// 		wLogSlot foCX
//				wDaData	 o͂ D/A f[^
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDaSetData(wLogSlot: Word; wDaData: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaSetData(wLogSlot, wDaData);
end;

//****************************************************************************
// 		ėp̓|[gf[^擾
// 		wLogSlot foCX
//				pdwEIn1	 EIn1 ̏
//				pdwEIn2	 EIn2 ̏
//				pdwEIn3	 EIn3 ̏
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wGetEIn(wLogSlot: Word; pdwEIn1: PDWord; pdwEIn2: PDWord; pdwEIn3: PDWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25GetEIn(wLogSlot, pdwEIn1, pdwEIn2, pdwEIn3);
end;

//****************************************************************************
// 		ėpo̓|[gf[^̐ݒ
// 		wLogSlot foCX
//				dwEOut1	 EOut1 ̏
//				dwEOut2	 EOut2 ̏
//				dwEOut3	 EOut3 ̏
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wSetEOut(wLogSlot: Word; dwEOut1: DWord; dwEOut2: DWord; dwEOut3: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25SetEOut(wLogSlot, dwEOut1, dwEOut2, dwEOut3);
end;

//****************************************************************************
// 		BSN ̒l擾(foCX̃{[hw)
// 		wLogSlot		 foCX
//				wSelBoard		 {[h
//				pdwSwitchValue BSN ̒li[AhX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wGetSwitchValueEx(wLogSlot: Word; wSelBoard: Word; pdwSwitchValue: PDWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25GetSwitchValueEx(wLogSlot, wSelBoard, pdwSwitchValue);
end;

//****************************************************************************
// 		aISA-A25 Zbg(foCX̃{[hw)
// 		wLogSlot	foCX
//				wSelBoard {[h
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wResetEx(wLogSlot: Word; wSelBoard: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25ResetEx(wLogSlot, wSelBoard);
end;

//****************************************************************************
// 		ADC Lu[V(foCX̃{[hw)
// 		wLogSlot	foCX
//				wSelBoard {[h
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdcEx(wLogSlot: Word; wSelBoard: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdcEx(wLogSlot, wSelBoard);
end;

//****************************************************************************
// 		CH Gg RAM ̎擾(foCX̃{[hw)
// 		wLogSlot	foCX
//				wSelBoard {[h
//				dwChCount `lGgRAM擾`lf[^̐w
//				pEntries	CH Gg RAM ̓ei[̈ւ̃|C^
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdGetChEntryEx(wLogSlot: Word; wSelBoard: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdGetChEntryEx(wLogSlot, wSelBoard, dwChCount, pEntries);
end;

//****************************************************************************
// 		CH Gg RAM ̓o^(foCX̃{[hw)
// 		wLogSlot	foCX
//				wSelBoard {[h
//				dwChCount `lGgRAMɃGg`lf[^̐w
//				pEntries	CH Gg RAM ̓ei[̈ւ̃|C^
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdSetChEntryEx(wLogSlot: Word; wSelBoard: Word; dwChCount: DWord; pEntries: PAISA25ADCHE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdSetChEntryEx(wLogSlot, wSelBoard, dwChCount, pEntries);
end;

//****************************************************************************
// 		A/D TvO샂[hݒ(foCX̃{[hw)
// 		wLogSlot	foCX
//				wSelBoard {[h
//				pmode		A/D [hݒf[^
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdSetModeEx(wLogSlot: Word; wSelBoard: Word; pmode: PAISA25ADM): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdSetModeEx(wLogSlot, wSelBoard, pmode);
end;

//****************************************************************************
// 		A/D EAB Rg[ SCN f[^o^ēݒ
// 		wLogSlot	foCX
//				peab		EAB Rg[ɐݒ肷̃AhX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdSetEab(wLogSlot: Word; peab: PAISA25ADE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdSetEab(wLogSlot, peab);
end;

//****************************************************************************
// 		A/D TvOJn(foCX̃{[hw)
// 		wLogSlot foCX
//				wSelBoard {[h
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdStartSamplingEx(wLogSlot: Word; wSelBoard: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdStartSamplingEx(wLogSlot, wSelBoard);
end;

//****************************************************************************
// 		A/D TvO~(foCX̃{[hw)
// 		wLogSlot foCX
//				wSelBoard {[h
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdStopSamplingEx(wLogSlot: Word; wSelBoard: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdStopSamplingEx(wLogSlot, wSelBoard);
end;

//****************************************************************************
// 		A/D TvȌԂ擾(foCX̃{[hw)
// 		wLogSlot	 foCX
//				wSelBoard	 {[h
//				pdwNumData TvOς݃f[^i[̈ւ̃AhX
//				pdwStatus	 TvOԂ̃Xe[^Xi[̈ւ̃AhX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdGetSamplingStatusEx(wLogSlot: Word; wSelBoard: Word; pdwNumData: PDWord; pdwStatus: PDWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdGetSamplingStatusEx(wLogSlot, wSelBoard, pdwNumData, pdwStatus);
end;

//****************************************************************************
// 		A/D TvOf[^̎擾(foCX̃{[hw)
// 		wLogSlot	 foCX
//				wSelBoard	 {[h
//				pdwNumData 擾f[^(ۂɎ擾f[^)
//				pwData	 f[^obt@ւ̃AhX
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wAdGetDataEx(wLogSlot: Word; wSelBoard: Word; pdwNumData: PDWord; pwData: PWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25AdGetDataEx(wLogSlot, wSelBoard, pdwNumData, pwData);
end;

//****************************************************************************
// 		D/A TvOx̐ݒ(foCX̃{[hw)
// 		wLogSlot	 foCX
//				wSelBoard	 {[h
//				dwSelClock D/A TvONbNݒ
//				dwTimer	 D/A TvO^Cݒ
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDaSetRateSamplingEx(wLogSlot: Word; wSelBoard: Word; dwSelClock: DWord; dwTimer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaSetRateSamplingEx(wLogSlot, wSelBoard, dwSelClock, dwTimer);
end;

//****************************************************************************
// 		D/A f[^̓o^(foCX̃{[hw)
// 		wLogSlot		foCX
//				wSelBoard		{[h
//				dwDaMode		D/A TvOf[^o^̑I
//				dwDataCount ރf[^̌
//				pwDataEntry D/A f[^ݒ肷z
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDaSetDataEntryEx(wLogSlot: Word; wSelBoard: Word; dwDaMode: DWord; dwDataCount: DWord; pwDataEntry: PWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaSetDataEntryEx(wLogSlot, wSelBoard, dwDaMode, dwDataCount, pwDataEntry);
end;

//****************************************************************************
// 		D/A TvOJn(foCX̃{[hw)
// 		wLogSlot	foCX
//			wSelBoard {[h
//			dwDaMode D/A TvO[h̑I
// ߂l True	
//			False	s
//****************************************************************************
function Aisa25wDaStartSamplingEx(wLogSlot: Word; wSelBoard: Word; dwDaMode: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaStartSamplingEx(wLogSlot, wSelBoard, dwDaMode);
end;

//****************************************************************************
// 		D/A TvO~(foCX̃{[hw)
// 		wLogSlot	foCX
//				wSelBoard {[h
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDaStopSamplingEx(wLogSlot: Word; wSelBoard: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaStopSamplingEx(wLogSlot, wSelBoard);
end;

//****************************************************************************
// 		D/A f[^o(foCX̃{[hw)
// 		wLogSlot	foCX
//				wSelBoard {[h
//				wDaData	o͂ D/A f[^
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wDaSetDataEx(wLogSlot: Word; wSelBoard: Word; wDaData: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25DaSetDataEx(wLogSlot, wSelBoard, wDaData);
end;

//****************************************************************************
// 		ėp̓|[gf[^擾(foCX̃{[hw)
// 		wLogSlot	foCX
//				wSelBoard {[h
//				pdwEIn1	EIn1 ̏
//				pdwEIn2	EIn2 ̏
//				pdwEIn3	EIn3 ̏
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wGetEInEx(wLogSlot: Word; wSelBoard: Word; pdwEIn1: PDWord; pdwEIn2: PDWord; pdwEIn3: PDWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25GetEInEx(wLogSlot, wSelBoard, pdwEIn1, pdwEIn2, pdwEIn3);
end;

//****************************************************************************
// 		ėpo̓|[gf[^̐ݒ(foCX̃{[hw)
// 		wLogSlot	foCX
//				wSelBoard {[h
//				dwEOut1	EOut1 ̏
//				dwEOut2	EOut2 ̏
//				dwEOut3	EOut3 ̏
// ߂l True	
//				False	s
//****************************************************************************
function Aisa25wSetEOutEx(wLogSlot: Word; wSelBoard: Word; dwEOut1: DWord; dwEOut2: DWord; dwEOut3: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa25SetEOutEx(wLogSlot, wSelBoard, dwEOut1, dwEOut2, dwEOut3);
end;

//****************************************************************************
// 		aISA-A25̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Aisa25wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA25_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa25GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Aisa25wGetDllExportFunc: Boolean;
begin
	Result := False;

	{ Aisa25GetVersion ̃AhX擾 }
	pAisa25GetVersion := GetProcAddress(hDLL, 'Aisa25GetVersion');
	if @pAisa25GetVersion = nil then Exit;

	{ Aisa25Create ̃AhX擾 }
	pAisa25Create := GetProcAddress(hDLL, 'Aisa25Create');
	if @pAisa25Create = nil then Exit;

	{ Aisa25Close ̃AhX擾 }
	pAisa25Close := GetProcAddress(hDLL, 'Aisa25Close');
	if @pAisa25Close = nil then Exit;

	{ Aisa25GetResource ̃AhX擾 }
	pAisa25GetResource := GetProcAddress(hDLL, 'Aisa25GetResource');
	if @pAisa25GetResource = nil then Exit;

	{ Aisa25GetNumBoard ̃AhX擾 }
	pAisa25GetNumBoard := GetProcAddress(hDLL, 'Aisa25GetNumBoard');
	if @pAisa25GetNumBoard = nil then Exit;

	{ Aisa25GetSwitchValue ̃AhX擾 }
	pAisa25GetSwitchValue := GetProcAddress(hDLL, 'Aisa25GetSwitchValue');
	if @pAisa25GetSwitchValue = nil then Exit;

	{ Aisa25Reset ̃AhX擾 }
	pAisa25Reset := GetProcAddress(hDLL, 'Aisa25Reset');
	if @pAisa25Reset = nil then Exit;

	{ Aisa25Adc ̃AhX擾 }
	pAisa25Adc := GetProcAddress(hDLL, 'Aisa25Adc');
	if @pAisa25Adc = nil then Exit;

	{ Aisa25AdGetChEntry ̃AhX擾 }
	pAisa25AdGetChEntry := GetProcAddress(hDLL, 'Aisa25AdGetChEntry');
	if @pAisa25AdGetChEntry = nil then Exit;

	{ Aisa25AdSetChEntry ̃AhX擾 }
	pAisa25AdSetChEntry := GetProcAddress(hDLL, 'Aisa25AdSetChEntry');
	if @pAisa25AdSetChEntry = nil then Exit;

	{ Aisa25AdSetMode ̃AhX擾 }
	pAisa25AdSetMode := GetProcAddress(hDLL, 'Aisa25AdSetMode');
	if @pAisa25AdSetMode = nil then Exit;

	{ Aisa25AdStartSampling ̃AhX擾 }
	pAisa25AdStartSampling := GetProcAddress(hDLL, 'Aisa25AdStartSampling');
	if @pAisa25AdStartSampling = nil then Exit;

	{ Aisa25AdStopSampling ̃AhX擾 }
	pAisa25AdStopSampling := GetProcAddress(hDLL, 'Aisa25AdStopSampling');
	if @pAisa25AdStopSampling = nil then Exit;

	{ Aisa25AdGetSamplingStatus ̃AhX擾 }
	pAisa25AdGetSamplingStatus := GetProcAddress(hDLL, 'Aisa25AdGetSamplingStatus');
	if @pAisa25AdGetSamplingStatus = nil then Exit;

	{ Aisa25AdGetData ̃AhX擾 }
	pAisa25AdGetData := GetProcAddress(hDLL, 'Aisa25AdGetData');
	if @pAisa25AdGetData = nil then Exit;

	{ Aisa25DaSetRateSampling ̃AhX擾 }
	pAisa25DaSetRateSampling := GetProcAddress(hDLL, 'Aisa25DaSetRateSampling');
	if @pAisa25DaSetRateSampling = nil then Exit;

	{ Aisa25DaSetDataEntry ̃AhX擾 }
	pAisa25DaSetDataEntry := GetProcAddress(hDLL, 'Aisa25DaSetDataEntry');
	if @pAisa25DaSetDataEntry = nil then Exit;

	{ Aisa25DaStartSampling ̃AhX擾 }
	pAisa25DaStartSampling := GetProcAddress(hDLL, 'Aisa25DaStartSampling');
	if @pAisa25DaStartSampling = nil then Exit;

	{ Aisa25DaStopSampling ̃AhX擾 }
	pAisa25DaStopSampling := GetProcAddress(hDLL, 'Aisa25DaStopSampling');
	if @pAisa25DaStopSampling = nil then Exit;

	{ Aisa25DaSetData ̃AhX擾 }
	pAisa25DaSetData := GetProcAddress(hDLL, 'Aisa25DaSetData');
	if @pAisa25DaSetData = nil then Exit;

	{ Aisa25GetEIn ̃AhX擾 }
	pAisa25GetEIn := GetProcAddress(hDLL, 'Aisa25GetEIn');
	if @pAisa25GetEIn = nil then Exit;

	{ Aisa25SetEOut ̃AhX擾 }
	pAisa25SetEOut := GetProcAddress(hDLL, 'Aisa25SetEOut');
	if @pAisa25SetEOut = nil then Exit;

	{ Aisa25GetLastError ̃AhX擾 }
	pAisa25GetLastError := GetProcAddress(hDLL, 'Aisa25GetLastError');
	if @pAisa25GetLastError = nil then Exit;

	{ Aisa25GetSwitchValueEx ̃AhX擾 }
	pAisa25GetSwitchValueEx := GetProcAddress(hDLL, 'Aisa25GetSwitchValueEx');
	if @pAisa25GetSwitchValueEx = nil then Exit;

	{ Aisa25ResetEx ̃AhX擾 }
	pAisa25ResetEx := GetProcAddress(hDLL, 'Aisa25ResetEx');
	if @pAisa25ResetEx = nil then Exit;

	{ Aisa25AdcEx ̃AhX擾 }
	pAisa25AdcEx := GetProcAddress(hDLL, 'Aisa25AdcEx');
	if @pAisa25AdcEx = nil then Exit;

	{ Aisa25AdGetChEntryEx ̃AhX擾 }
	pAisa25AdGetChEntryEx := GetProcAddress(hDLL, 'Aisa25AdGetChEntryEx');
	if @pAisa25AdGetChEntryEx = nil then Exit;

	{ Aisa25AdSetChEntryEx ̃AhX擾 }
	pAisa25AdSetChEntryEx := GetProcAddress(hDLL, 'Aisa25AdSetChEntryEx');
	if @pAisa25AdSetChEntryEx = nil then Exit;

	{ Aisa25AdSetModeEx ̃AhX擾 }
	pAisa25AdSetModeEx := GetProcAddress(hDLL, 'Aisa25AdSetModeEx');
	if @pAisa25AdSetModeEx = nil then Exit;

	{ Aisa25AdSetEab ̃AhX擾 }
	pAisa25AdSetEab := GetProcAddress(hDLL, 'Aisa25AdSetEab');
	if @pAisa25AdSetEab = nil then Exit;

	{ Aisa25AdStartSamplingEx ̃AhX擾 }
	pAisa25AdStartSamplingEx := GetProcAddress(hDLL, 'Aisa25AdStartSamplingEx');
	if @pAisa25AdStartSamplingEx = nil then Exit;

	{ Aisa25AdStopSamplingEx ̃AhX擾 }
	pAisa25AdStopSamplingEx := GetProcAddress(hDLL, 'Aisa25AdStopSamplingEx');
	if @pAisa25AdStopSamplingEx = nil then Exit;

	{ Aisa25AdGetSamplingStatusEx ̃AhX擾 }
	pAisa25AdGetSamplingStatusEx := GetProcAddress(hDLL, 'Aisa25AdGetSamplingStatusEx');
	if @pAisa25AdGetSamplingStatusEx = nil then Exit;

	{ Aisa25AdGetDataEx ̃AhX擾 }
	pAisa25AdGetDataEx := GetProcAddress(hDLL, 'Aisa25AdGetDataEx');
	if @pAisa25AdGetDataEx = nil then Exit;

	{ Aisa25DaSetRateSamplingEx ̃AhX擾 }
	pAisa25DaSetRateSamplingEx := GetProcAddress(hDLL, 'Aisa25DaSetRateSamplingEx');
	if @pAisa25DaSetRateSamplingEx = nil then Exit;

	{ Aisa25DaSetDataEntryEx ̃AhX擾 }
	pAisa25DaSetDataEntryEx := GetProcAddress(hDLL, 'Aisa25DaSetDataEntryEx');
	if @pAisa25DaSetDataEntryEx = nil then Exit;

	{ Aisa25DaStartSamplingEx ̃AhX擾 }
	pAisa25DaStartSamplingEx := GetProcAddress(hDLL, 'Aisa25DaStartSamplingEx');
	if @pAisa25DaStartSamplingEx = nil then Exit;

	{ Aisa25DaStopSamplingEx ̃AhX擾 }
	pAisa25DaStopSamplingEx := GetProcAddress(hDLL, 'Aisa25DaStopSamplingEx');
	if @pAisa25DaStopSamplingEx = nil then Exit;

	{ Aisa25DaSetDataEx ̃AhX擾 }
	pAisa25DaSetDataEx := GetProcAddress(hDLL, 'Aisa25DaSetDataEx');
	if @pAisa25DaSetDataEx = nil then Exit;

	{ Aisa25GetEInEx ̃AhX擾 }
	pAisa25GetEInEx := GetProcAddress(hDLL, 'Aisa25GetEInEx');
	if @pAisa25GetEInEx = nil then Exit;

	{ Aisa25SetEOutEx ̃AhX擾 }
	pAisa25SetEOutEx := GetProcAddress(hDLL, 'Aisa25SetEOutEx');
	if @pAisa25SetEOutEx = nil then Exit;

	Result := True;	{ SĂ DLL GNX|[g֐AhX擾 }
end;

//****************************************************************************
// 		aISA-A25 ̃bZ[W lParam  foCX ID	̒l擾
// 		lParam	bZ[W
// ߂l foCX ID
//****************************************************************************
function Aisa25GetDeviceID(lParam: LPARAM): Word;
begin
		Result := Word(lParam);
end;

//****************************************************************************
// 		aISA-A25 ̃bZ[W wParam  wLogSlot ̒l擾
// 		wParam	bZ[W
// ߂l wLogSlot
//****************************************************************************
function Aisa25GetLogSlot(wParam: WPARAM): Word;
begin
		Result := Word(wParam);
end;

//****************************************************************************
// 		aISA-A25 ̃bZ[W wParam  wSelBoard ̒l擾
// 		wParam	bZ[W
// ߂l wSelBoard
//****************************************************************************
function Aisa25GetSelBoard(wParam: WPARAM): Word;
begin
		Result := Word((DWord(wParam) shr 16) and $FFFF)
end;

end.
