Attribute VB_Name = "aisa25w"
'*****************************************************************************'
'*  aisa25w.bas                                                              *'
'*                                                                           *'
'*  aISA-A25                                                             *'
'*                                                                           *'
'*  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                  *'
'*                                                                           *'
'*  Date 1999/03/09                                                          *'
'*                                                                           *'
'*****************************************************************************'
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal HMODULE As Long, ByVal lpProcName As String) As Long

Global Const AISA25_DLL_NAME = "aisa25.dll" ' DLL

Dim hDLL As Long                            ' DLLւ̃nh

Global Const AISA25_ERR_WRAPDLL = -1        ' bp[֐G[

' DLL GNX|[g֐AhX̊i[
Private Const ApiGetVersion = 1
Private Const ApiCreate = ApiGetVersion + 1
Private Const ApiClose = ApiCreate + 1
Private Const ApiGetResource = ApiClose + 1
Private Const ApiGetNumBoard = ApiGetResource + 1
Private Const ApiGetSwitchValue = ApiGetNumBoard + 1
Private Const ApiReset = ApiGetSwitchValue + 1
Private Const ApiAdc = ApiReset + 1
Private Const ApiAdGetChEntry = ApiAdc + 1
Private Const ApiAdSetChEntry = ApiAdGetChEntry + 1
Private Const ApiAdSetMode = ApiAdSetChEntry + 1
Private Const ApiAdStartSampling = ApiAdSetMode + 1
Private Const ApiAdStopSampling = ApiAdStartSampling + 1
Private Const ApiAdGetSamplingStatus = ApiAdStopSampling + 1
Private Const ApiAdGetData = ApiAdGetSamplingStatus + 1
Private Const ApiDaSetRateSampling = ApiAdGetData + 1
Private Const ApiDaSetDataEntry = ApiDaSetRateSampling + 1
Private Const ApiDaStartSampling = ApiDaSetDataEntry + 1
Private Const ApiDaStopSampling = ApiDaStartSampling + 1
Private Const ApiDaSetData = ApiDaStopSampling + 1
Private Const ApiGetEIn = ApiDaSetData + 1
Private Const ApiSetEOut = ApiGetEIn + 1
Private Const ApiGetLastError = ApiSetEOut + 1
Private Const ApiGetSwitchValueEx = ApiGetLastError + 1
Private Const ApiResetEx = ApiGetSwitchValueEx + 1
Private Const ApiAdcEx = ApiResetEx + 1
Private Const ApiAdGetChEntryEx = ApiAdcEx + 1
Private Const ApiAdSetChEntryEx = ApiAdGetChEntryEx + 1
Private Const ApiAdSetModeEx = ApiAdSetChEntryEx + 1
Private Const ApiAdSetEab = ApiAdSetModeEx + 1
Private Const ApiAdStartSamplingEx = ApiAdSetEab + 1
Private Const ApiAdStopSamplingEx = ApiAdStartSamplingEx + 1
Private Const ApiAdGetSamplingStatusEx = ApiAdStopSamplingEx + 1
Private Const ApiAdGetDataEx = ApiAdGetSamplingStatusEx + 1
Private Const ApiDaSetRateSamplingEx = ApiAdGetDataEx + 1
Private Const ApiDaSetDataEntryEx = ApiDaSetRateSamplingEx + 1
Private Const ApiDaStartSamplingEx = ApiDaSetDataEntryEx + 1
Private Const ApiDaStopSamplingEx = ApiDaStartSamplingEx + 1
Private Const ApiDaSetDataEx = ApiDaStopSamplingEx + 1
Private Const ApiGetEInEx = ApiDaSetDataEx + 1
Private Const ApiSetEOutEx = ApiGetEInEx + 1
Private Const ApiLast = ApiSetEOutEx

'*****************************************************************************'
'*    aisa25.dll[h                                                 *'
'*                                                                   *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDllOpen() As Boolean

    Aisa25wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AISA25_DLL_NAME)
    If hDLL = 0 Then Exit Function

    If Aisa25wGetDllExportFunc() = False Then
        Aisa25wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Aisa25wDllOpen = True

End Function

'*****************************************************************************'
'*    aisa25.dllA[h                                             *'
'*                                                                   *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDllClose() As Boolean

    Aisa25wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa25wDllClose = False

End Function

'*****************************************************************************'
'*    aISA-A25 DLL,Driver̃o[Wԍ擾                            *'
'*    pdwDllVer DLLo[Wԍi[                                  *'
'*        pdwDrvVer Drivero[Wԍi[                               *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean

    Aisa25wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Aisa25GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function

    Aisa25wGetVersion = True

End Function

'*****************************************************************************'
'*    aISA-A25̔Cӂ̃foCX̎gp錾                               *'
'*    pwLogSlot gpfoCXi[AhX                       *'
'*        hWnd      bZ[W𑗂EBhEnh                       *'
'*        uWMBase   ƂȂ郁bZ[WID                                   *'
'*        pvInitArg gp(0Zbg)                                        *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wCreate(ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Long) As Boolean

    Aisa25wCreate = False

    If hDLL = 0 Then Exit Function

    If Aisa25Create(pwLogSlot, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function

    Aisa25wCreate = True

End Function

'*****************************************************************************'
'*    aISA-A25̔Cӂ̃foCX̎gpJ                               *'
'*    wLogSlot gpfoCX                                          *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wClose(ByVal wLogSlot As Integer) As Boolean

    Aisa25wClose = False

    If hDLL = 0 Then Exit Function

    If Aisa25Close(wLogSlot) = 0 Then Exit Function

    Aisa25wClose = True

End Function

'*****************************************************************************'
'*    wfoCX̃\[X擾                                   *'
'*    wLogSlot foCX                                          *'
'*        pres     \[Xi[\                              *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wGetResource(ByVal wLogSlot As Integer, ByRef pres As AISA25RESOURCE) As Boolean

    Aisa25wGetResource = False

    If hDLL = 0 Then Exit Function

    If Aisa25GetResource(wLogSlot, pres) = 0 Then Exit Function

    Aisa25wGetResource = True

End Function

'*****************************************************************************'
'*    }X^{[h܂߂{[h擾                                 *'
'*    wLogSlot   foCX                                        *'
'*        pwNumBoard {[h̐i[AhX                            *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wGetNumBoard(ByVal wLogSlot As Integer, ByRef pwNumBoard As Integer) As Boolean

    Aisa25wGetNumBoard = False

    If hDLL = 0 Then Exit Function

    If Aisa25GetNumBoard(wLogSlot, pwNumBoard) = 0 Then Exit Function

    Aisa25wGetNumBoard = True

End Function

'*****************************************************************************'
'*    BSN ̒l擾                                                     *'
'*    wLogSlot       foCX                                    *'
'*        pdwSwitchValue BSN ̒li[AhX                          *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wGetSwitchValue(ByVal wLogSlot As Integer, ByRef pdwSwitchValue As Long) As Boolean

    Aisa25wGetSwitchValue = False

    If hDLL = 0 Then Exit Function

    If Aisa25GetSwitchValue(wLogSlot, pdwSwitchValue) = 0 Then Exit Function

    Aisa25wGetSwitchValue = True

End Function

'*****************************************************************************'
'*    aISA-A25 Zbg                                                *'
'*    wLogSlot foCX                                          *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wReset(ByVal wLogSlot As Integer) As Boolean

    Aisa25wReset = False

    If hDLL = 0 Then Exit Function

    If Aisa25Reset(wLogSlot) = 0 Then Exit Function

    Aisa25wReset = True

End Function

'*****************************************************************************'
'*    ADC Lu[V                                             *'
'*    wLogSlot foCX                                          *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdc(ByVal wLogSlot As Integer) As Boolean

    Aisa25wAdc = False

    If hDLL = 0 Then Exit Function

    If Aisa25Adc(wLogSlot) = 0 Then Exit Function

    Aisa25wAdc = True

End Function

'*****************************************************************************'
'*    CH Gg RAM ̎擾                                             *'
'*    wLogSlot  foCX                                         *'
'*        dwChCount `lGgRAM擾`lf[^̐w  *'
'*        pEntries  CH Gg RAM ̓ei[̈ւ̃|C^         *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdGetChEntry(ByVal wLogSlot As Integer, ByVal dwChCount As Long, ByRef pEntries() As AISA25ADCHE) As Boolean

    Aisa25wAdGetChEntry = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdGetChEntry(wLogSlot, dwChCount, pEntries(LBound(pEntries))) = 0 Then Exit Function

    Aisa25wAdGetChEntry = True

End Function

'*****************************************************************************'
'*    CH Gg RAM ̓o^                                             *'
'*    wLogSlot  foCX                                         *'
'*        dwChCount `lGgRAMɃGg`lf[^̐w*'
'*        pEntries  CH Gg RAM ̓ei[̈ւ̃|C^         *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdSetChEntry(ByVal wLogSlot As Integer, ByVal dwChCount As Long, ByRef pEntries() As AISA25ADCHE) As Boolean

    Aisa25wAdSetChEntry = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdSetChEntry(wLogSlot, dwChCount, pEntries(LBound(pEntries))) = 0 Then Exit Function

    Aisa25wAdSetChEntry = True

End Function

'*****************************************************************************'
'*    A/D TvO샂[hݒ                                     *'
'*    wLogSlot foCX                                          *'
'*        pmode    A/D [hݒf[^                                      *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdSetMode(ByVal wLogSlot As Integer, ByRef pmode As AISA25ADMODE) As Boolean

    Aisa25wAdSetMode = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdSetMode(wLogSlot, pmode) = 0 Then Exit Function

    Aisa25wAdSetMode = True

End Function

'*****************************************************************************'
'*    A/D TvOJn                                               *'
'*    wLogSlot foCX                                          *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdStartSampling(ByVal wLogSlot As Integer) As Boolean

    Aisa25wAdStartSampling = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdStartSampling(wLogSlot) = 0 Then Exit Function

    Aisa25wAdStartSampling = True

End Function

'*****************************************************************************'
'*    A/D TvO~                                               *'
'*    wLogSlot foCX                                          *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdStopSampling(ByVal wLogSlot As Integer) As Boolean

    Aisa25wAdStopSampling = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdStopSampling(wLogSlot) = 0 Then Exit Function

    Aisa25wAdStopSampling = True

End Function

'*****************************************************************************'
'*    A/D TvȌԂ擾                                     *'
'*    wLogSlot   foCX                                        *'
'*        pdwNumData TvOς݃f[^i[̈ւ̃AhX      *'
'*        pdwStatus  TvOԂ̃Xe[^Xi[̈ւ̃AhX  *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdGetSamplingStatus(ByVal wLogSlot As Integer, ByRef pdwNumData As Long, ByRef pdwStatus As Long) As Boolean

    Aisa25wAdGetSamplingStatus = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdGetSamplingStatus(wLogSlot, pdwNumData, pdwStatus) = 0 Then Exit Function

    Aisa25wAdGetSamplingStatus = True

End Function

'*****************************************************************************'
'*    A/D TvOf[^̎擾                                       *'
'*    wLogSlot   foCX                                        *'
'*        pdwNumData 擾f[^(ۂɎ擾f[^)                *'
'*        pwData     f[^obt@ւ̃AhX                              *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdGetData(ByVal wLogSlot As Integer, ByRef pdwNumData As Long, ByRef pwData() As Integer) As Boolean

    Aisa25wAdGetData = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdGetData(wLogSlot, pdwNumData, pwData(LBound(pwData))) = 0 Then Exit Function

    Aisa25wAdGetData = True

End Function

'*****************************************************************************'
'*    D/A TvOx̐ݒ                                         *'
'*    wLogSlot   foCX                                        *'
'*        dwSelClock D/A TvONbNݒ                            *'
'*        dwTimer    D/A TvO^Cݒ                              *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaSetRateSampling(ByVal wLogSlot As Integer, ByVal dwSelClock As Long, ByVal dwTimer As Long) As Boolean

    Aisa25wDaSetRateSampling = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaSetRateSampling(wLogSlot, dwSelClock, dwTimer) = 0 Then Exit Function

    Aisa25wDaSetRateSampling = True

End Function

'*****************************************************************************'
'*    D/A f[^̓o^                                                   *'
'*    wLogSlot    foCX                                       *'
'*        dwDaMode    D/A TvOf[^o^̑I                       *'
'*        dwDataCount ރf[^̌                                   *'
'*        pwDataEntry D/A f[^ݒ肷z                               *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaSetDataEntry(ByVal wLogSlot As Integer, ByVal dwDaMode As Long, ByVal dwDataCount As Long, ByRef pwDataEntry() As Integer) As Boolean

    Aisa25wDaSetDataEntry = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaSetDataEntry(wLogSlot, dwDaMode, dwDataCount, pwDataEntry(LBound(pwDataEntry))) = 0 Then Exit Function

    Aisa25wDaSetDataEntry = True

End Function

'*****************************************************************************'
'*    D/A TvOJn                                               *'
'*    wLogSlot foCX                                          *'
'*        dwDaMode D/A TvO[h̑I                              *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaStartSampling(ByVal wLogSlot As Integer, ByVal dwDaMode As Long) As Boolean

    Aisa25wDaStartSampling = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaStartSampling(wLogSlot, dwDaMode) = 0 Then Exit Function

    Aisa25wDaStartSampling = True

End Function

'*****************************************************************************'
'*    D/A TvO~                                               *'
'*    wLogSlot foCX                                          *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaStopSampling(ByVal wLogSlot As Integer) As Boolean

    Aisa25wDaStopSampling = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaStopSampling(wLogSlot) = 0 Then Exit Function

    Aisa25wDaStopSampling = True

End Function

'*****************************************************************************'
'*    D/A f[^o                                                   *'
'*    wLogSlot foCX                                          *'
'*        wDaData  o͂ D/A f[^                                       *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaSetData(ByVal wLogSlot As Integer, ByVal wDaData As Integer) As Boolean

    Aisa25wDaSetData = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaSetData(wLogSlot, wDaData) = 0 Then Exit Function

    Aisa25wDaSetData = True

End Function

'*****************************************************************************'
'*    ėp̓|[gf[^擾                                           *'
'*    wLogSlot foCX                                          *'
'*        pdwEIn1  EIn1 ̏                                               *'
'*        pdwEIn2  EIn2 ̏                                               *'
'*        pdwEIn3  EIn3 ̏                                               *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wGetEIn(ByVal wLogSlot As Integer, ByRef pdwEIn1 As Long, ByRef pdwEIn2 As Long, ByRef pdwEIn3 As Long) As Boolean

    Aisa25wGetEIn = False

    If hDLL = 0 Then Exit Function

    If Aisa25GetEIn(wLogSlot, pdwEIn1, pdwEIn2, pdwEIn3) = 0 Then Exit Function

    Aisa25wGetEIn = True

End Function

'*****************************************************************************'
'*    ėpo̓|[gf[^̐ݒ                                         *'
'*    wLogSlot foCX                                          *'
'*        dwEOut1  EOut1 ̏                                              *'
'*        dwEOut2  EOut2 ̏                                              *'
'*        dwEOut3  EOut3 ̏                                              *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wSetEOut(ByVal wLogSlot As Integer, ByVal dwEOut1 As Long, ByVal dwEOut2 As Long, ByVal dwEOut3 As Long) As Boolean

    Aisa25wSetEOut = False

    If hDLL = 0 Then Exit Function

    If Aisa25SetEOut(wLogSlot, dwEOut1, dwEOut2, dwEOut3) = 0 Then Exit Function

    Aisa25wSetEOut = True

End Function

'*****************************************************************************'
'*    BSN ̒l擾(foCX̃{[hw)                   *'
'*    wLogSlot       foCX                                    *'
'*        wSelBoard      {[h                                      *'
'*        pdwSwitchValue BSN ̒li[AhX                          *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wGetSwitchValueEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pdwSwitchValue As Long) As Boolean

    Aisa25wGetSwitchValueEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25GetSwitchValueEx(wLogSlot, wSelBoard, pdwSwitchValue) = 0 Then Exit Function

    Aisa25wGetSwitchValueEx = True

End Function

'*****************************************************************************'
'*    aISA-A25 Zbg(foCX̃{[hw)              *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wResetEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Boolean

    Aisa25wResetEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25ResetEx(wLogSlot, wSelBoard) = 0 Then Exit Function

    Aisa25wResetEx = True

End Function

'*****************************************************************************'
'*    ADC Lu[V(foCX̃{[hw)           *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdcEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Boolean

    Aisa25wAdcEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdcEx(wLogSlot, wSelBoard) = 0 Then Exit Function

    Aisa25wAdcEx = True

End Function

'*****************************************************************************'
'*    CH Gg RAM ̎擾(foCX̃{[hw)           *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'*        dwChCount `lGgRAM擾`lf[^̐w  *'
'*        pEntries  CH Gg RAM ̓ei[̈ւ̃|C^         *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdGetChEntryEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwChCount As Long, ByRef pEntries() As AISA25ADCHE) As Boolean

    Aisa25wAdGetChEntryEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdGetChEntryEx(wLogSlot, wSelBoard, dwChCount, pEntries(LBound(pEntries))) = 0 Then Exit Function

    Aisa25wAdGetChEntryEx = True

End Function

'*****************************************************************************'
'*    CH Gg RAM ̓o^(foCX̃{[hw)           *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'*        dwChCount `lGgRAMɃGg`lf[^̐w*'
'*        pEntries  CH Gg RAM ̓ei[̈ւ̃|C^         *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdSetChEntryEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwChCount As Long, ByRef pEntries() As AISA25ADCHE) As Boolean

    Aisa25wAdSetChEntryEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdSetChEntryEx(wLogSlot, wSelBoard, dwChCount, pEntries(LBound(pEntries))) = 0 Then Exit Function

    Aisa25wAdSetChEntryEx = True

End Function

'*****************************************************************************'
'*    A/D TvO샂[hݒ(foCX̃{[hw)   *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'*        pmode     A/D [hݒf[^                                     *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdSetModeEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pmode As AISA25ADMODE) As Boolean

    Aisa25wAdSetModeEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdSetModeEx(wLogSlot, wSelBoard, pmode) = 0 Then Exit Function

    Aisa25wAdSetModeEx = True

End Function

'*****************************************************************************'
'*    A/D EAB Rg[ SCN f[^o^ēݒ              *'
'*    wLogSlot  foCX                                         *'
'*        peab      EAB Rg[ɐݒ肷̃AhX                 *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdSetEab(ByVal wLogSlot As Integer, ByRef peab As AISA25ADEAB) As Boolean

    Aisa25wAdSetEab = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdSetEab(wLogSlot, peab) = 0 Then Exit Function

    Aisa25wAdSetEab = True

End Function

'*****************************************************************************'
'*    A/D TvOJn(foCX̃{[hw)             *'
'*    wLogSlot foCX                                          *'
'*        wSelBoard {[h                                           *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdStartSamplingEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Boolean

    Aisa25wAdStartSamplingEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdStartSamplingEx(wLogSlot, wSelBoard) = 0 Then Exit Function

    Aisa25wAdStartSamplingEx = True

End Function

'*****************************************************************************'
'*    A/D TvO~(foCX̃{[hw)             *'
'*    wLogSlot foCX                                          *'
'*        wSelBoard {[h                                           *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdStopSamplingEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Boolean

    Aisa25wAdStopSamplingEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdStopSamplingEx(wLogSlot, wSelBoard) = 0 Then Exit Function

    Aisa25wAdStopSamplingEx = True

End Function

'*****************************************************************************'
'*    A/D TvȌԂ擾(foCX̃{[hw)   *'
'*    wLogSlot   foCX                                        *'
'*        wSelBoard  {[h                                          *'
'*        pdwNumData TvOς݃f[^i[̈ւ̃AhX      *'
'*        pdwStatus  TvOԂ̃Xe[^Xi[̈ւ̃AhX  *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdGetSamplingStatusEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pdwNumData As Long, ByRef pdwStatus As Long) As Boolean

    Aisa25wAdGetSamplingStatusEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdGetSamplingStatusEx(wLogSlot, wSelBoard, pdwNumData, pdwStatus) = 0 Then Exit Function

    Aisa25wAdGetSamplingStatusEx = True

End Function

'*****************************************************************************'
'*    A/D TvOf[^̎擾(foCX̃{[hw)     *'
'*    wLogSlot   foCX                                        *'
'*        wSelBoard  {[h                                          *'
'*        pdwNumData 擾f[^(ۂɎ擾f[^)                *'
'*        pwData     f[^obt@ւ̃AhX                              *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wAdGetDataEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pdwNumData As Long, ByRef pwData() As Integer) As Boolean

    Aisa25wAdGetDataEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25AdGetDataEx(wLogSlot, wSelBoard, pdwNumData, pwData(LBound(pwData))) = 0 Then Exit Function

    Aisa25wAdGetDataEx = True

End Function

'*****************************************************************************'
'*    D/A TvOx̐ݒ(foCX̃{[hw)       *'
'*    wLogSlot   foCX                                        *'
'*        wSelBoard  {[h                                          *'
'*        dwSelClock D/A TvONbNݒ                            *'
'*        dwTimer    D/A TvO^Cݒ                              *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaSetRateSamplingEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwSelClock As Long, ByVal dwTimer As Long) As Boolean

    Aisa25wDaSetRateSamplingEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaSetRateSamplingEx(wLogSlot, wSelBoard, dwSelClock, dwTimer) = 0 Then Exit Function

    Aisa25wDaSetRateSamplingEx = True

End Function

'*****************************************************************************'
'*    D/A f[^̓o^(foCX̃{[hw)                 *'
'*    wLogSlot    foCX                                       *'
'*        wSelBoard   {[h                                         *'
'*        dwDaMode    D/A TvOf[^o^̑I                       *'
'*        dwDataCount ރf[^̌                                   *'
'*        pwDataEntry D/A f[^ݒ肷z                               *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaSetDataEntryEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwDaMode As Long, ByVal dwDataCount As Long, ByRef pwDataEntry() As Integer) As Boolean

    Aisa25wDaSetDataEntryEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaSetDataEntryEx(wLogSlot, wSelBoard, dwDaMode, dwDataCount, pwDataEntry(LBound(pwDataEntry))) = 0 Then Exit Function

    Aisa25wDaSetDataEntryEx = True

End Function

'*****************************************************************************'
'*    D/A TvOJn(foCX̃{[hw)             *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'*        dwDaMode D/A TvO[h̑I                              *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaStartSamplingEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwDaMode As Long) As Boolean

    Aisa25wDaStartSamplingEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaStartSamplingEx(wLogSlot, wSelBoard, dwDaMode) = 0 Then Exit Function

    Aisa25wDaStartSamplingEx = True

End Function

'*****************************************************************************'
'*    D/A TvO~(foCX̃{[hw)             *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaStopSamplingEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer) As Boolean

    Aisa25wDaStopSamplingEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaStopSamplingEx(wLogSlot, wSelBoard) = 0 Then Exit Function

    Aisa25wDaStopSamplingEx = True

End Function

'*****************************************************************************'
'*    D/A f[^o(foCX̃{[hw)                 *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'*        wDaData   o͂ D/A f[^                                      *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wDaSetDataEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal wDaData As Integer) As Boolean

    Aisa25wDaSetDataEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25DaSetDataEx(wLogSlot, wSelBoard, wDaData) = 0 Then Exit Function

    Aisa25wDaSetDataEx = True

End Function

'*****************************************************************************'
'*    ėp̓|[gf[^擾(foCX̃{[hw)         *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'*        pdwEIn1   EIn1 ̏                                              *'
'*        pdwEIn2   EIn2 ̏                                              *'
'*        pdwEIn3   EIn3 ̏                                              *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wGetEInEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByRef pdwEIn1 As Long, ByRef pdwEIn2 As Long, ByRef pdwEIn3 As Long) As Boolean

    Aisa25wGetEInEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25GetEInEx(wLogSlot, wSelBoard, pdwEIn1, pdwEIn2, pdwEIn3) = 0 Then Exit Function

    Aisa25wGetEInEx = True

End Function

'*****************************************************************************'
'*    ėpo̓|[gf[^̐ݒ(foCX̃{[hw)       *'
'*    wLogSlot  foCX                                         *'
'*        wSelBoard {[h                                           *'
'*        dwEOut1   EOut1 ̏                                             *'
'*        dwEOut2   EOut2 ̏                                             *'
'*        dwEOut3   EOut3 ̏                                             *'
'* ߂l True                                                           *'
'*        False s                                                         *'
'*****************************************************************************'
Function Aisa25wSetEOutEx(ByVal wLogSlot As Integer, ByVal wSelBoard As Integer, ByVal dwEOut1 As Long, ByVal dwEOut2 As Long, ByVal dwEOut3 As Long) As Boolean

    Aisa25wSetEOutEx = False

    If hDLL = 0 Then Exit Function

    If Aisa25SetEOutEx(wLogSlot, wSelBoard, dwEOut1, dwEOut2, dwEOut3) = 0 Then Exit Function

    Aisa25wSetEOutEx = True

End Function

'*****************************************************************************'
'*    aISA-A25̃G[R[h                                             *'
'*    wLogSlot  G[foCX                                 *'
'* ߂l G[R[h                                                       *'
'*****************************************************************************'
Function Aisa25wGetLastError(ByVal wLogSlot As Integer) As Long

    Aisa25wGetLastError = AISA25_ERR_WRAPDLL

    If hDLL = 0 Then Exit Function

    Aisa25wGetLastError = Aisa25GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*'
'*    DLLGNX|[g֐AhX̎擾                                  *'
'*                                                                   *'
'* ߂l  True                                                          *'
'*        s False                                                         *'
'*---------------------------------------------------------------------------*'
Function Aisa25wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    Dim i As Integer

    ' GNX|[g֐
    Dim szApiName(1 To ApiLast) As String

    szApiName(ApiGetVersion) = "Aisa25GetVersion"
    szApiName(ApiCreate) = "Aisa25Create"
    szApiName(ApiClose) = "Aisa25Close"
    szApiName(ApiGetResource) = "Aisa25GetResource"
    szApiName(ApiGetNumBoard) = "Aisa25GetNumBoard"
    szApiName(ApiGetSwitchValue) = "Aisa25GetSwitchValue"
    szApiName(ApiReset) = "Aisa25Reset"
    szApiName(ApiAdc) = "Aisa25Adc"
    szApiName(ApiAdGetChEntry) = "Aisa25AdGetChEntry"
    szApiName(ApiAdSetChEntry) = "Aisa25AdSetChEntry"
    szApiName(ApiAdSetMode) = "Aisa25AdSetMode"
    szApiName(ApiAdStartSampling) = "Aisa25AdStartSampling"
    szApiName(ApiAdStopSampling) = "Aisa25AdStopSampling"
    szApiName(ApiAdGetSamplingStatus) = "Aisa25AdGetSamplingStatus"
    szApiName(ApiAdGetData) = "Aisa25AdGetData"
    szApiName(ApiDaSetRateSampling) = "Aisa25DaSetRateSampling"
    szApiName(ApiDaSetDataEntry) = "Aisa25DaSetDataEntry"
    szApiName(ApiDaStartSampling) = "Aisa25DaStartSampling"
    szApiName(ApiDaStopSampling) = "Aisa25DaStopSampling"
    szApiName(ApiDaSetData) = "Aisa25DaSetData"
    szApiName(ApiGetEIn) = "Aisa25GetEIn"
    szApiName(ApiSetEOut) = "Aisa25SetEOut"
    szApiName(ApiGetLastError) = "Aisa25GetLastError"
    szApiName(ApiGetSwitchValueEx) = "Aisa25GetSwitchValueEx"
    szApiName(ApiResetEx) = "Aisa25ResetEx"
    szApiName(ApiAdcEx) = "Aisa25AdcEx"
    szApiName(ApiAdGetChEntryEx) = "Aisa25AdGetChEntryEx"
    szApiName(ApiAdSetChEntryEx) = "Aisa25AdSetChEntryEx"
    szApiName(ApiAdSetModeEx) = "Aisa25AdSetModeEx"
    szApiName(ApiAdSetEab) = "Aisa25AdSetEab"
    szApiName(ApiAdStartSamplingEx) = "Aisa25AdStartSamplingEx"
    szApiName(ApiAdStopSamplingEx) = "Aisa25AdStopSamplingEx"
    szApiName(ApiAdGetSamplingStatusEx) = "Aisa25AdGetSamplingStatusEx"
    szApiName(ApiAdGetDataEx) = "Aisa25AdGetDataEx"
    szApiName(ApiDaSetRateSamplingEx) = "Aisa25DaSetRateSamplingEx"
    szApiName(ApiDaSetDataEntryEx) = "Aisa25DaSetDataEntryEx"
    szApiName(ApiDaStartSamplingEx) = "Aisa25DaStartSamplingEx"
    szApiName(ApiDaStopSamplingEx) = "Aisa25DaStopSamplingEx"
    szApiName(ApiDaSetDataEx) = "Aisa25DaSetDataEx"
    szApiName(ApiGetEInEx) = "Aisa25GetEInEx"
    szApiName(ApiSetEOutEx) = "Aisa25SetEOutEx"

    Aisa25wGetDllExportFunc = False

    For i = 1 To ApiLast

        pFunc = GetProcAddress(hDLL, szApiName(i))
        If (pFunc = 0) Then Exit Function

    Next i

    Aisa25wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
