//===================================================================
// Aisa25.h - aISA-A25 Win 9x DLL Header
// Copyright (c) ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================

#ifndef __INC_AISA25_H__
#define __INC_AISA25_H__

#ifdef __cplusplus
extern "C" {
#endif


//-----------------------------------------------------------
// Miscellaneous
//-----------------------------------------------------------

#define AISA25_MAX_SLOTS	8			// Maximum number of slots
										// (Master Board)

#define AISA25_SLOT_AUTO	((WORD)~0U) // default search

//-----------------------------------------------------------
//	Device ID
//-----------------------------------------------------------
#define AISA25_VENDOR_ID				0x8B04
#define AISA25_DEVICE_ID				0x2541

#define Aisa25GetDeviceID(lParam)		LOWORD(lParam)

//-----------------------------------------------------------
//	Board Select
//-----------------------------------------------------------

#define AISA25_EAB_BOARD_MAX	9		// P_XbgŊǗ
										// Ƃł{[h̐
#define AISA25_EAB_MASTER		0		// }X^{[hI
#define AISA25_EAB_TARGET_0		1		// PԖڂ̃^[Qbg{[hI
#define AISA25_EAB_TARGET_1		2		// Q			V
#define AISA25_EAB_TARGET_2		3		// R			V
#define AISA25_EAB_TARGET_3		4		// S			V
#define AISA25_EAB_TARGET_4		5		// T			V
#define AISA25_EAB_TARGET_5		6		// U			V
#define AISA25_EAB_TARGET_6		7		// V			V
#define AISA25_EAB_TARGET_7		8		// W			V

//-----------------------------------------------------------
// ėpo͂̒l
//-----------------------------------------------------------

#define AISA25_EIO_OFF		0
#define AISA25_EIO_ON		((DWORD)~0LU)


//-----------------------------------------------------------
// Error codes
//-----------------------------------------------------------

#define AISA25_ERR_SYSTEM				5000 // Windows  GetLastError() R[ĂB
											 // ̃tH_ɃhCoȂ\܂B
#define AISA25_ERR_NO_DEVICE			5001 // gp\ȃfoCX܂B
#define AISA25_ERR_IN_USED				5002 // w̃foCX͎gpłB
#define AISA25_ERR_INVALID_ARGUMENT		5003 // Invalid Argument(s)
#define AISA25_ERR_INVALID_SLOT			5004 // Ș_XbgłB
#define AISA25_ERR_INVALID_SEL_BOARD	5005 // ȃ{[hI܂B
#define AISA25_ERR_NOT_CREATED			5006 // foCXNGCgĂ܂B
#define AISA25_ERR_AIF					5007 // AiO I/F G[܂B
#define AISA25_ERR_TIMEOUT				5008 // ^CAEg܂B
#define AISA25_ERR_NUMDATA				5009 // w肳ꂽ̃f[^obt@ɑ݂܂B
#define AISA25_ERR_NOT_ENOUGH_MEM		5010 // \ȃmۏo܂łB
#define AISA25_ERR_AD_CH_ENTRY_COUNT	5011 // A/D CH Gg̐ݒ肪słB
#define AISA25_ERR_AD_CH_ANALOG			5012 // A/D CH AiO̓`l̐ݒ肪słB
#define AISA25_ERR_AD_CH_SDBU			5013 // A/D CH oC|[-j|[AVOGh-fBt@V
											 // ̐ݒ肪słB
#define AISA25_ERR_AD_CH_GAIN			5014 // A/D CH QC̐ݒ肪słB
#define AISA25_ERR_AD_MODE				5015 // A/D TvO[h̐ݒ肪słB
#define AISA25_ERR_AD_CH_ADDR			5016 // A/D TvO`lAhX̐ݒ肪słB
#define AISA25_ERR_AD_SAMPLING_RATE		5017 // A/D TvOx̐ݒ肪słB
#define AISA25_ERR_AD_SAMPLING_COUNT	5018 // A/D TvO񐔂̐ݒ肪słB
#define AISA25_ERR_AD_BUFF				5019 // A/D TvOobt@̐ݒ肪słB
#define AISA25_ERR_AD_SCN				5020 // A/D XLԍ̐ݒ肪słB
#define AISA25_ERR_AD_TRG_MODE			5021 // A/D xgK[h̐ݒ肪słB
#define AISA25_ERR_AD_TRG_DAC			5022 // A/D xgK DAC lsłB
#define AISA25_ERR_AD_TRG_EVENT			5023 // A/D xgKCxg񐔂̐ݒ肪słB
#define AISA25_ERR_NOT_EAB				5024 // EAB @\͎gpł܂B
#define AISA25_ERR_EAB_SCN_ADDR			5025 // EAB SCN AhX̐ݒ肪słB
#define AISA25_ERR_EAB_SCN_COUNT		5026 // EAB SCN o^̐ݒ肪słB
#define AISA25_ERR_EAB_SCN				5027 // EAB SCN ̐ݒ肪słB
#define AISA25_ERR_AD_START				5028 // A/D TvOJnł܂BAdSetMode sĂ
											 // B
#define AISA25_ERR_AD_BUSY				5029 // A/D Rg[ғłB
#define AISA25_ERR_AD_BUFF_NOT_EMPTY	5030 // A/D hCoobt@Ƀf[^cĂ܂BAdGetData ܂
											 // AdSetMode sĂB
#define AISA25_ERR_AD_SYNC_START		5031 // A/D TvȌꍇA^[QbgJnł܂B
#define AISA25_ERR_AD_SYNC_STOP			5032 // A/D TvȌꍇA^[Qbg~ł܂B
#define AISA25_ERR_AD_SYNC_SCN			5033 // A/D TvOAVOTvȌꍇAXL
											 // ԍ(SCN)𓝈ꂵĂB
#define AISA25_ERR_AD_SYNC_CNV_RATE		5034 // A/D TvO̕ϊxA܂̓}X^̃^C}
											 // ݒlsłB
#define AISA25_ERR_AD_SYNC_BUFF			5035 // A/D TvȌꍇA}X^ƃ^[Qbg̃obt@TCY
											 // 𓝈ꂵĂB
#define AISA25_ERR_DA_MODE				5036 // D/A [h̐ݒ肪słB
#define AISA25_ERR_DA_SAMPLING_RATE		5037 // D/A TvOx̐ݒ肪słB
#define AISA25_ERR_DA_ENTRY_COUNT		5038 // D/A TvOf[^słB
#define AISA25_ERR_DA_BUSY				5039 // D/A Rg[ғłB
#define AISA25_ERR_DA_ENTRY_DATA		5040 // D/A TvOf[^o^Ă܂B

#define AISA25_ERR_INTERNAL				5100 // Send mail to us
#define AISA25_ERR_UNKNOWN				5101 // Help me!
#define AISA25_SUCCESS					   0 // Successfully proccessed


//-----------------------------------------------------------
// Resource information structure
//-----------------------------------------------------------

#define AISA25_MAX_MEM	   9		/* number of memory windows */
#define AISA25_MAX_IO	  20		/* number of i/o windows */
#define AISA25_MAX_IRQ	   7		/* number of irqs */
#define AISA25_MAX_DMA	   7		/* number of dmas */

typedef struct _AISA25RESOURCE
{
	DWORD	 dwNumMemWindows;					 /* Not used */
	DWORD	 dwMemBase		  [AISA25_MAX_MEM];	 /* Not used */
	DWORD	 dwMemLength	  [AISA25_MAX_MEM];	 /* Not used */
	DWORD	 dwMemAttrib	  [AISA25_MAX_MEM];	 /* Not used */
	DWORD	 dwNumIOPorts;						 /* Num IO ports */
	DWORD	 dwIOPortBase	  [AISA25_MAX_IO];	 /* I/O port base */
	DWORD	 dwIOPortLength	  [AISA25_MAX_IO];	 /* I/O port length */
	DWORD	 dwNumIRQs;							 /* Num IRQ info */
	DWORD	 dwIRQRegisters	  [AISA25_MAX_IRQ];	 /* IRQ list */
	DWORD	 dwIRQAttrib	  [AISA25_MAX_IRQ];	 /* IRQ Attrib list */
	DWORD	 dwNumDMAs;							 /* Not used */
	DWORD	 dwDMALst		  [AISA25_MAX_DMA];	 /* Not used */
	DWORD	 dwDMAAttrib	  [AISA25_MAX_DMA];	 /* Not used */
	DWORD	 dwReserved1	  [3];				 /* Not used */
} AISA25RESOURCE, *PAISA25R;


//-----------------------------------------------------------
// Channel Entry Data structure
//-----------------------------------------------------------

// ݒ`l̃AhX
#define AISA25_AD_CH_ADDR_MAX	16

#define AISA25_AD_CH_ADDR_FIRST	0x00
#define AISA25_AD_CH_0H			0x00
#define AISA25_AD_CH_1H			0x01
#define AISA25_AD_CH_2H			0x02
#define AISA25_AD_CH_3H			0x03
#define AISA25_AD_CH_4H			0x04
#define AISA25_AD_CH_5H			0x05
#define AISA25_AD_CH_6H			0x06
#define AISA25_AD_CH_7H			0x07
#define AISA25_AD_CH_8H			0x08
#define AISA25_AD_CH_9H			0x09
#define AISA25_AD_CH_AH			0x0A
#define AISA25_AD_CH_BH			0x0B
#define AISA25_AD_CH_CH			0x0C
#define AISA25_AD_CH_DH			0x0D
#define AISA25_AD_CH_EH			0x0E
#define AISA25_AD_CH_FH			0x0F
#define AISA25_AD_CH_ADDR_LAST	0x0F

// ̓`l̐ݒl
#define AISA25_AD_CH_MAX		16

#define AISA25_AD_CH_FIRST		0
#define AISA25_AD_CH_01			0
#define AISA25_AD_CH_02			1
#define AISA25_AD_CH_03			2
#define AISA25_AD_CH_04			3
#define AISA25_AD_CH_05			4
#define AISA25_AD_CH_06			5
#define AISA25_AD_CH_07			6
#define AISA25_AD_CH_08			7
#define AISA25_AD_CH_09			8
#define AISA25_AD_CH_10			9
#define AISA25_AD_CH_11			10
#define AISA25_AD_CH_12			11
#define AISA25_AD_CH_13			12
#define AISA25_AD_CH_14			13
#define AISA25_AD_CH_15			14
#define AISA25_AD_CH_16			15
#define AISA25_AD_CH_LAST_D		 7		// fBt@V͎̍ŏIl
#define AISA25_AD_CH_LAST_S		15		// VOGh͎̍ŏIl

						 // dwSdBu b SingleEnd/Differentialb Bipolar-Unipolar
						 // ---------------------------------------------------
#define AISA25_AD_SDBU_0	0	// b		SingleEnd		b	   Bipolar
#define AISA25_AD_SDBU_1	1	// b		SingleEnd		b	   Unipolar
#define AISA25_AD_SDBU_2	2	// b	   Differential		b	   Bipolar
#define AISA25_AD_SDBU_3	3	// b	   Differential		b	   Unipolar

						  // dwGainb Gain b Bipolar b Unipolar
						  // ------------------------------------------
#define AISA25_AD_GAIN_01	1	// b 1 { b }10V	  b 0`+10V
#define AISA25_AD_GAIN_05	5	// b 5 { b }2V	  b 0`+2V
#define AISA25_AD_GAIN_10	10	// b 10{ b }1V	  b 0`+1V
#define AISA25_AD_GAIN_50	50	// b 50{ b }200mV b 0`+200mV

typedef struct _AISA25ADCHE
{
	DWORD dwChAnalog;		// AiO̓`lw
	DWORD dwSdBu;			// VOGh-ft@VAoC|[-j|[̎w
	DWORD dwGain;			// 1{A5{A10{A50{̒w
} AISA25ADCHE, *PAISA25ADCHE;

//-----------------------------------------------------------
// Sampling definition
//-----------------------------------------------------------

// TvO[h
						// dwAdModeb  -ĕ@	 bݸމ񐔁bb		荞	  b
						// -------------------------------------  ---------------------
#define AISA25_AD_MODE_00	0	// b	 	 b		1	   bb		   EOC		  b
#define AISA25_AD_MODE_01	1	// b	 	 b	 1`65536  bb	   ݸEND	  b
#define AISA25_AD_MODE_02	2	// bض b	 1`65536  bb	   ݸEND	  b
#define AISA25_AD_MODE_03	3	// bOض b	 1`65536  bb	   ݸEND	  b
#define AISA25_AD_MODE_04	4	// b	 	 b			   bbFIFO HALF,FULL,OVRFb
#define AISA25_AD_MODE_05	5	// b  Oض	 b		1	   bb		   EOC		  b
#define AISA25_AD_MODE_06	6	// b߽ضށb	 1`65536  bb	   ݸEND	  b
#define AISA25_AD_MODE_07	7	// bO߽ضށb	 1`65536  bb	   ݸEND	  b
#define AISA25_AD_MODE_08	8	// bϽްނbϽްނ̐݁bb	 Ͻްނ̐ݒ	  b
								// b	 bɂ	   bb		ɂ		  b

				   // dwSelCnvRate	   bϊx
				   // ---------------------------------------
#define AISA25_AD_RATE_LOW		0	// b20us
#define AISA25_AD_RATE_HIGH		1	// b10us

				   // dwSelClock	   bNbN
				   // ---------------------------------------
#define AISA25_AD_CLOCK_100K	0	// b100KHz
#define AISA25_AD_CLOCK_10M		1	// b 10MHz
#define AISA25_AD_CLOCK_EXT		2	// b O

#define AISA25_AD_TIME_MIN_CL100K	1		// NbN 100KHz I̍ŏl
#define AISA25_AD_TIME_MIN_CL10M	100		// NbN 10MHz I̍ŏl
											// ̃NbNŏĺAϊx HIGH ɂꍇ̒l
											// ϊx LOW ɂꍇ́AŏlQ{ɂȂ܂B
#define AISA25_AD_TIME_MIN_CLEXT	1		// ONbNI̍ŏl
#define AISA25_AD_TIME_MAX			65536

#define AISA25_AD_COUNT_MIN			1		// TvO񐔂̍ŏl
#define AISA25_AD_COUNT_MAX			65536	// TvO񐔂̍ől

#define AISA25_AD_BUFF_MIN			1		// obt@TCY̍ŏl

		//			   dwTrgMode   bxgK[h			 bdwTrgLvl1bdwTrgLvl2b
		//			 --------------------------------------------------------------------
#define AISA25_AD_LVLTRG_0	0	// bGbWgK		 b	   	b		   b
#define AISA25_AD_LVLTRG_1	1	// bオGbWgK		 b	   	b		   b
#define AISA25_AD_LVLTRG_2	2	// bCEChgK(͈͓)	 b	   	b	     b
#define AISA25_AD_LVLTRG_3	3	// bAEgEChgK(͈͊O)b	   	b	     b
#define AISA25_AD_LVLTRG_4	4	// b}CiXX[vgK		 b	   	b	     b
#define AISA25_AD_LVLTRG_5	5	// bvXX[vgK		 b	   	b	     b

#define AISA25_AD_LVLTRG_DAC		0xFF	// AiO͐MK

#define AISA25_AD_LVLTRG_EVENT_MIN	0		// gK̍ŏl
#define AISA25_AD_LVLTRG_EVENT_MAX	65536	// gK̍ől

#define AISA25_AD_EAB_SCN_FIRST		0x00	// EAB Scan Number First
#define AISA25_AD_EAB_SCN_0			0x00	//		  V	   0
#define AISA25_AD_EAB_SCN_1			0x01	//		  V	   1
#define AISA25_AD_EAB_SCN_2			0x02	//		  V	   2
#define AISA25_AD_EAB_SCN_3			0x03	//		  V	   3
#define AISA25_AD_EAB_SCN_4			0x04	//		  V	   4
#define AISA25_AD_EAB_SCN_5			0x05	//		  V	   5
#define AISA25_AD_EAB_SCN_6			0x06	//		  V	   6
#define AISA25_AD_EAB_SCN_7			0x07	//		  V	   7
#define AISA25_AD_EAB_SCN_LAST		0x07	//		  V	   Last

typedef struct _AISA25ADMODE
{
	DWORD dwMode;			// 샂[h
	DWORD dwChAddrFirst;	// TvOJn`lAhX(0-15)
	DWORD dwChAddrLast;		// TvOI`lAhX(0-15)
	DWORD dwSelCnvRate;		// ϊx
	DWORD dwSelClock;		// TvONbN
	DWORD dwTimer;			// TvO^C}(1-65536)
	DWORD dwCount;			// TvO񐔂ݒ(1-65536)
	DWORD dwBuffer;			// obt@TCYAIɊmۂłlől
	DWORD dwTrgMode;		// xgK[hݒ
	DWORD dwTrgLvl1;		// xgKDACl1̐ݒ(00`FFh ͓dWɂ܂)
							// {dwTrgLvl1 > dwTrgLvl2}
	DWORD dwTrgLvl2;		// xgKDACl2̐ݒ(00`FFh ͓dWɂ܂)
	DWORD dwTrgEvent;		// Cxg(0-65536)
	DWORD dwScn;			// e{[h EAB XLԍ(SCN)
} AISA25ADMODE, *PAISA25ADM;

typedef CONST AISA25ADMODE *PCAISA25ADM;

// SCN ݒ̃AhX
#define AISA25_AD_SCN_ADDR_MAX	16

#define AISA25_AD_SCN_ADDR_FIRST	0x00
#define AISA25_AD_SCN_0H			0x00
#define AISA25_AD_SCN_1H			0x01
#define AISA25_AD_SCN_2H			0x02
#define AISA25_AD_SCN_3H			0x03
#define AISA25_AD_SCN_4H			0x04
#define AISA25_AD_SCN_5H			0x05
#define AISA25_AD_SCN_6H			0x06
#define AISA25_AD_SCN_7H			0x07
#define AISA25_AD_SCN_8H			0x08
#define AISA25_AD_SCN_9H			0x09
#define AISA25_AD_SCN_AH			0x0A
#define AISA25_AD_SCN_BH			0x0B
#define AISA25_AD_SCN_CH			0x0C
#define AISA25_AD_SCN_DH			0x0D
#define AISA25_AD_SCN_EH			0x0E
#define AISA25_AD_SCN_FH			0x0F
#define AISA25_AD_SCN_ADDR_LAST		0x0F

typedef struct _AISA25ADEAB
{
	DWORD dwScnAddrFirst;					 // EAB Jn SCN Gg RAM AhX
	DWORD dwScnAddrLast;					 // EAB I SCN Gg RAM AhX
	DWORD dwScnCount;						 // EAB SCN Gg RAM ւ̓o^f[^
	DWORD dwScnEntry[AISA25_AD_SCN_ADDR_MAX];// EAB SCN Gg RAM ւ̓o^f[^
} AISA25ADEAB, *PAISA25ADE;

typedef CONST AISA25ADEAB *PCAISA25ADE;


// TvOXe[^X
#define AISA25_STS_SAMPLING			 0x01
#define AISA25_STS_EOC				 0x02
#define AISA25_STS_SAMPLING_END		 0x04
#define AISA25_STS_BUFF_HALF_FULL	 0x08
#define AISA25_STS_BUFF_FULL		 0x10
#define AISA25_STS_BUFF_OVERFLOW	 0x20
#define AISA25_STS_SAMPLING_OVERRUN	 0x40
#define AISA25_STS_FIFO_EXIST		 0x80		// FIFO obt@Ƀf[^݂

// Aisa25Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
// ItZbglbZ[Wo܂B
#ifndef WM_EOC
#define WM_EOC							0
#define WM_SAMPLING_END					1
#define WM_BUFF_HALF_FULL				2
#define WM_BUFF_FULL					3
#define WM_BUFF_OVERFLOW				4
#define WM_SAMPLING_OVERRUN				5
#endif // WM_EOC

// bZ[W wParam  wLogSlot ̒l擾
#define Aisa25GetLogSlot(wParam)		LOWORD(wParam)
// bZ[W wParam  wSelBoard ̒l擾
#define Aisa25GetSelBoard(wParam)		HIWORD(wParam)

//-----------------------------------------------------------
// DA TvO^C}̃NbN
//-----------------------------------------------------------
				   // dwSelClock	   bNbN
				   // ---------------------------------------
#define AISA25_DA_CLOCK_100K	0	// b100KHz
#define AISA25_DA_CLOCK_10M		1	// b 10MHz

#define AISA25_DA_TIME_MIN_CL10M	100		// NbN 10MHz I̍ŏl
#define AISA25_DA_TIME_MIN_CL100K	1		// NbN 100KHz I̍ŏl
#define AISA25_DA_TIME_MAX			65536

#define AISA25_DA_DATA_ALL_MAX		32768
#define AISA25_DA_DATA_BANK_MAX		4096

#define AISA25_DA_BANK_MAX			8		// D/A oN̍ő吔

#define AISA25_DA_MODE_ALL			((DWORD)~0U)
#define AISA25_DA_MODE_BANK_0		0
#define AISA25_DA_MODE_BANK_1		1
#define AISA25_DA_MODE_BANK_2		2
#define AISA25_DA_MODE_BANK_3		3
#define AISA25_DA_MODE_BANK_4		4
#define AISA25_DA_MODE_BANK_5		5
#define AISA25_DA_MODE_BANK_6		6
#define AISA25_DA_MODE_BANK_7		7


//-----------------------------------------------------------
// API Functions
//-----------------------------------------------------------

#if !defined(AISA25_DRIVER)

#if !defined(AISA25_DLL)
	#define AISA25_API __declspec(dllimport)
#else
	#define AISA25_API
#endif

// ʏgp
AISA25_API BOOL	 WINAPI Aisa25GetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer);
AISA25_API BOOL	 WINAPI Aisa25Create(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg);
AISA25_API BOOL	 WINAPI Aisa25Close(WORD wLogSlot);
AISA25_API BOOL	 WINAPI Aisa25GetResource(WORD wLogSlot, PAISA25R pres);
AISA25_API BOOL	 WINAPI Aisa25GetNumBoard(WORD wLogSlot, PWORD pwNumBoard);
AISA25_API BOOL	 WINAPI Aisa25GetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue);
AISA25_API BOOL	 WINAPI Aisa25Reset(WORD wLogSlot);
AISA25_API BOOL	 WINAPI Aisa25Adc(WORD wLogSlot);
AISA25_API BOOL	 WINAPI Aisa25AdGetChEntry(WORD wLogSlot, DWORD dwChCount, PAISA25ADCHE pEntries);
AISA25_API BOOL	 WINAPI Aisa25AdSetChEntry(WORD wLogSlot, DWORD dwChCount, PAISA25ADCHE pEntries);
AISA25_API BOOL	 WINAPI Aisa25AdSetMode(WORD wLogSlot, PCAISA25ADM pmode);
AISA25_API BOOL	 WINAPI Aisa25AdStartSampling(WORD wLogSlot);
AISA25_API BOOL	 WINAPI Aisa25AdStopSampling(WORD wLogSlot);
AISA25_API BOOL	 WINAPI Aisa25AdGetSamplingStatus(WORD wLogSlot, PDWORD pdwNumData, PDWORD pdwStatus);
AISA25_API BOOL	 WINAPI Aisa25AdGetData(WORD wLogSlot, PDWORD pdwNumData, PWORD pwData);
AISA25_API BOOL	 WINAPI Aisa25DaSetRateSampling(WORD wLogSlot, DWORD dwSelClock, DWORD dwTimer);
AISA25_API BOOL	 WINAPI Aisa25DaSetDataEntry(WORD wLogSlot, DWORD dwDaMode, DWORD dwDataCount, PWORD pwDataEntry);
AISA25_API BOOL	 WINAPI Aisa25DaStartSampling(WORD wLogSlot, DWORD dwDaMode);
AISA25_API BOOL	 WINAPI Aisa25DaStopSampling(WORD wLogSlot);
AISA25_API BOOL	 WINAPI Aisa25DaSetData(WORD wLogSlot, WORD wDaData);
AISA25_API BOOL	 WINAPI Aisa25GetEIn(WORD wLogSlot, PDWORD pdwEIn1, PDWORD pdwEIn2, PDWORD pdwEIn3);
AISA25_API BOOL	 WINAPI Aisa25SetEOut(WORD wLogSlot, DWORD dwEOut1, DWORD dwEOut2, DWORD dwEOut3);
AISA25_API DWORD WINAPI Aisa25GetLastError(WORD wLogSlot);

// EAB gp
AISA25_API BOOL	 WINAPI Aisa25GetSwitchValueEx(WORD wLogSlot, WORD wSelBoard, PDWORD pdwSwitchValue);
AISA25_API BOOL	 WINAPI Aisa25ResetEx(WORD wLogSlot, WORD wSelBoard);
AISA25_API BOOL	 WINAPI Aisa25AdcEx(WORD wLogSlot, WORD wSelBoard);
AISA25_API BOOL	 WINAPI Aisa25AdGetChEntryEx(WORD wLogSlot, WORD wSelBoard, DWORD dwChCount, PAISA25ADCHE pEntries);
AISA25_API BOOL	 WINAPI Aisa25AdSetChEntryEx(WORD wLogSlot, WORD wSelBoard, DWORD dwChCount, PAISA25ADCHE pEntries);
AISA25_API BOOL	 WINAPI Aisa25AdSetModeEx(WORD wLogSlot, WORD wSelBoard, PCAISA25ADM pmode);
AISA25_API BOOL	 WINAPI Aisa25AdSetEab(WORD wLogSlot, PCAISA25ADE peab);
AISA25_API BOOL	 WINAPI Aisa25AdStartSamplingEx(WORD wLogSlot, WORD wSelBoard);
AISA25_API BOOL	 WINAPI Aisa25AdStopSamplingEx(WORD wLogSlot, WORD wSelBoard);
AISA25_API BOOL	 WINAPI Aisa25AdGetSamplingStatusEx(WORD wLogSlot, WORD wSelBoard, PDWORD pdwNumData, PDWORD pdwStatus);
AISA25_API BOOL	 WINAPI Aisa25AdGetDataEx(WORD wLogSlot, WORD wSelBoard, PDWORD pdwNumData, PWORD pwData);
AISA25_API BOOL	 WINAPI Aisa25DaSetRateSamplingEx(WORD wLogSlot, WORD wSelBoard, DWORD dwSelClock, DWORD dwTimer);
AISA25_API BOOL	 WINAPI Aisa25DaSetDataEntryEx(WORD wLogSlot, WORD wSelBoard, DWORD dwDaMode, DWORD dwDataCount, PWORD pwDataEntry);
AISA25_API BOOL	 WINAPI Aisa25DaStartSamplingEx(WORD wLogSlot, WORD wSelBoard, DWORD dwDaMode);
AISA25_API BOOL	 WINAPI Aisa25DaStopSamplingEx(WORD wLogSlot, WORD wSelBoard);
AISA25_API BOOL	 WINAPI Aisa25DaSetDataEx(WORD wLogSlot, WORD wSelBoard, WORD wDaData);
AISA25_API BOOL	 WINAPI Aisa25GetEInEx(WORD wLogSlot, WORD wSelBoard, PDWORD pdwEIn1, PDWORD pdwEIn2, PDWORD pdwEIn3);
AISA25_API BOOL	 WINAPI Aisa25SetEOutEx(WORD wLogSlot, WORD wSelBoard, DWORD dwEOut1, DWORD dwEOut2, DWORD dwEOut3);

#endif	// AISA25_DRIVER


#ifdef __cplusplus
}
#endif

#endif __INC_AISA25_H__
