/*****************************************************************************/
/*	aisa25w.c																 */
/*																			 */
/*	aISA-A25															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/11/17															 */
/*																			 */
/*****************************************************************************/

#define STRICT

#include <windows.h>
#include <tchar.h>

#include "aisa25w.h"	// aISA-A25

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Aisa25wGetDllExportFunc();


/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[
const static enum ApiIdx
{
	ApiGetVersion,
	ApiCreate,
	ApiClose,
	ApiGetResource,
	ApiGetNumBoard,
	ApiGetSwitchValue,
	ApiReset,
	ApiAdc,
	ApiAdGetChEntry,
	ApiAdSetChEntry,
	ApiAdSetMode,
	ApiAdStartSampling,
	ApiAdStopSampling,
	ApiAdGetSamplingStatus,
	ApiAdGetData,
	ApiDaSetRateSampling,
	ApiDaSetDataEntry,
	ApiDaStartSampling,
	ApiDaStopSampling,
	ApiDaSetData,
	ApiGetEIn,
	ApiSetEOut,
	ApiGetLastError,
	ApiGetSwitchValueEx,
	ApiResetEx,
	ApiAdcEx,
	ApiAdGetChEntryEx,
	ApiAdSetChEntryEx,
	ApiAdSetModeEx,
	ApiAdSetEab,
	ApiAdStartSamplingEx,
	ApiAdStopSamplingEx,
	ApiAdGetSamplingStatusEx,
	ApiAdGetDataEx,
	ApiDaSetRateSamplingEx,
	ApiDaSetDataEntryEx,
	ApiDaStartSamplingEx,
	ApiDaStopSamplingEx,
	ApiDaSetDataEx,
	ApiGetEInEx,
	ApiSetEOutEx,
	ApiLast
};

static FARPROC pAisa25[ApiLast];


/*****************************************************************************/
/* 	  aisa25.dll[h												 */
/* 	  																 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(AISA25_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Aisa25wGetDllExportFunc() == FALSE)
	{
		Aisa25wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  aisa25.dllA[h											 */
/* 	  																 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

/*****************************************************************************/
/* 	  aISA-A25 DLL,Driver̃o[Wԍ擾							 */
/* 	  pdwDllVer DLLo[Wԍi[AhX						 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiGetVersion])(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aISA-A25̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot gpfoCXi[AhX						 */
/*		  hWnd		bZ[W𑗂EBhEnh						 */
/*		  uWMBase	ƂȂ郁bZ[WID									 */
/*		  pvInitArg NULL ݒ												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiCreate])(pwLogSlot, hWnd, uWMBase, pvInitArg);
}

/*****************************************************************************/
/* 	  aISA-A25̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiClose])(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot foCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wGetResource(WORD wLogSlot, PAISA25R pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiGetResource])(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  }X^{[h܂߂{[h擾								 */
/* 	  wLogSlot	 foCX										 */
/*		  pwNumBoard {[h̐i[AhX							 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wGetNumBoard(WORD wLogSlot, PWORD pwNumBoard)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiGetNumBoard])(wLogSlot, pwNumBoard);
}

/*****************************************************************************/
/* 	  BSN ̒l擾													 */
/* 	  wLogSlot		 foCX									 */
/*		  pdwSwitchValue BSN ̒li[AhX							 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiGetSwitchValue])(wLogSlot, pdwSwitchValue);
}

/*****************************************************************************/
/* 	  aISA-A25 Zbg												 */
/* 	  wLogSlot foCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wReset(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiReset])(wLogSlot);
}

/*****************************************************************************/
/* 	  ADC Lu[V											 */
/* 	  wLogSlot foCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdc(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdc])(wLogSlot);
}

/*****************************************************************************/
/* 	  CH Gg RAM ̎擾											 */
/* 	  wLogSlot	foCX										 */
/*		  dwChCount `lGgRAM擾`lf[^̐w	 */
/*		  pEntries	CH Gg RAM ̓ei[̈ւ̃|C^		 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdGetChEntry(WORD wLogSlot, DWORD dwChCount, PAISA25ADCHE pEntries)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdGetChEntry])(wLogSlot, dwChCount, pEntries);
}

/*****************************************************************************/
/* 	  CH Gg RAM ̓o^											 */
/* 	  wLogSlot	foCX										 */
/*		  dwChCount `lGgRAMɃGg`lf[^̐w*/
/*		  pEntries	CH Gg RAM ̓ei[̈ւ̃|C^		 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdSetChEntry(WORD wLogSlot, DWORD dwChCount, PAISA25ADCHE pEntries)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdSetChEntry])(wLogSlot, dwChCount, pEntries);
}

/*****************************************************************************/
/* 	  A/D TvO샂[hݒ									 */
/* 	  wLogSlot foCX											 */
/*		  pmode	   A/D [hݒf[^										 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdSetMode(WORD wLogSlot, PCAISA25ADM pmode)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdSetMode])(wLogSlot, pmode);
}

/*****************************************************************************/
/* 	  A/D TvOJn												 */
/* 	  wLogSlot foCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdStartSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdStartSampling])(wLogSlot);
}

/*****************************************************************************/
/* 	  A/D TvO~												 */
/* 	  wLogSlot foCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdStopSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdStopSampling])(wLogSlot);
}

/*****************************************************************************/
/* 	  A/D TvȌԂ擾									 */
/* 	  wLogSlot	 foCX										 */
/*		  pdwNumData TvOς݃f[^i[̈ւ̃AhX		 */
/*		  pdwStatus	 TvOԂ̃Xe[^Xi[̈ւ̃AhX	 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdGetSamplingStatus(WORD wLogSlot, PDWORD pdwNumData, PDWORD pdwStatus)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdGetSamplingStatus])(wLogSlot, pdwNumData, pdwStatus);
}

/*****************************************************************************/
/* 	  A/D TvOf[^̎擾										 */
/* 	  wLogSlot	 foCX										 */
/*		  pdwNumData 擾f[^(ۂɎ擾f[^)				 */
/*		  pwData	 f[^obt@ւ̃AhX								 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdGetData(WORD wLogSlot, PDWORD pdwNumData, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdGetData])(wLogSlot, pdwNumData, pwData);
}

/*****************************************************************************/
/* 	  D/A TvOx̐ݒ										 */
/* 	  wLogSlot	 foCX										 */
/*		  dwSelClock D/A TvONbNݒ							 */
/*		  dwTimer	 D/A TvO^Cݒ								 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaSetRateSampling(WORD wLogSlot, DWORD dwSelClock, DWORD dwTimer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaSetRateSampling])(wLogSlot, dwSelClock, dwTimer);
}

/*****************************************************************************/
/* 	  D/A f[^̓o^													 */
/* 	  wLogSlot	  foCX										 */
/*		  dwDaMode	  D/A TvOf[^o^̑I						 */
/*		  dwDataCount ރf[^̌									 */
/*		  pwDataEntry D/A f[^ݒ肷z								 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaSetDataEntry(WORD wLogSlot, DWORD dwDaMode, DWORD dwDataCount, PWORD pwDataEntry)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaSetDataEntry])(wLogSlot, dwDaMode, dwDataCount, pwDataEntry);
}

/*****************************************************************************/
/* 	  D/A TvOJn												 */
/* 	  wLogSlot foCX											 */
/*		  dwDaMode D/A TvO[h̑I								 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaStartSampling(WORD wLogSlot, DWORD dwDaMode)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaStartSampling])(wLogSlot, dwDaMode);
}

/*****************************************************************************/
/* 	  D/A TvO~												 */
/* 	  wLogSlot foCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaStopSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaStopSampling])(wLogSlot);
}

/*****************************************************************************/
/* 	  D/A f[^o													 */
/* 	  wLogSlot foCX											 */
/*		  wDaData  o͂ D/A f[^										 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaSetData(WORD wLogSlot, WORD wDaData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaSetData])(wLogSlot, wDaData);
}

/*****************************************************************************/
/* 	  ėp̓|[gf[^擾											 */
/* 	  wLogSlot foCX											 */
/*		  pdwEIn1  EIn1 ̏												 */
/*		  pdwEIn2  EIn2 ̏												 */
/*		  pdwEIn3  EIn3 ̏												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wGetEIn(WORD wLogSlot, PDWORD pdwEIn1, PDWORD pdwEIn2, PDWORD pdwEIn3)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiGetEIn])(wLogSlot, pdwEIn1, pdwEIn2, pdwEIn3);
}

/*****************************************************************************/
/* 	  ėpo̓|[gf[^̐ݒ										 */
/* 	  wLogSlot foCX											 */
/*		  dwEOut1  EOut1 ̏												 */
/*		  dwEOut2  EOut2 ̏												 */
/*		  dwEOut3  EOut3 ̏												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wSetEOut(WORD wLogSlot, DWORD dwEOut1, DWORD dwEOut2, DWORD dwEOut3)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiSetEOut])(wLogSlot, dwEOut1, dwEOut2, dwEOut3);
}

/*****************************************************************************/
/* 	  BSN ̒l擾(foCX̃{[hw)					 */
/* 	  wLogSlot		 foCX									 */
/*		  wSelBoard		 {[h										 */
/*		  pdwSwitchValue BSN ̒li[AhX							 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wGetSwitchValueEx(WORD wLogSlot, WORD wSelBoard, PDWORD pdwSwitchValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiGetSwitchValueEx])(wLogSlot, wSelBoard, pdwSwitchValue);
}

/*****************************************************************************/
/* 	  aISA-A25 Zbg(foCX̃{[hw)				 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wResetEx(WORD wLogSlot, WORD wSelBoard)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiResetEx])(wLogSlot, wSelBoard);
}

/*****************************************************************************/
/* 	  ADC Lu[V(foCX̃{[hw)			 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdcEx(WORD wLogSlot, WORD wSelBoard)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdcEx])(wLogSlot, wSelBoard);
}

/*****************************************************************************/
/* 	  CH Gg RAM ̎擾(foCX̃{[hw)			 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/*		  dwChCount `lGgRAM擾`lf[^̐w	 */
/*		  pEntries	CH Gg RAM ̓ei[̈ւ̃|C^		 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdGetChEntryEx(WORD wLogSlot, WORD wSelBoard, DWORD dwChCount, PAISA25ADCHE pEntries)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdGetChEntryEx])(wLogSlot, wSelBoard, dwChCount, pEntries);
}

/*****************************************************************************/
/* 	  CH Gg RAM ̓o^(foCX̃{[hw)			 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/*		  dwChCount `lGgRAMɃGg`lf[^̐w*/
/*		  pEntries	CH Gg RAM ̓ei[̈ւ̃|C^		 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdSetChEntryEx(WORD wLogSlot, WORD wSelBoard, DWORD dwChCount, PAISA25ADCHE pEntries)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdSetChEntryEx])(wLogSlot, wSelBoard, dwChCount, pEntries);
}

/*****************************************************************************/
/* 	  A/D TvO샂[hݒ(foCX̃{[hw)	 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/*		  pmode		A/D [hݒf[^									 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdSetModeEx(WORD wLogSlot, WORD wSelBoard, PCAISA25ADM pmode)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdSetModeEx])(wLogSlot, wSelBoard, pmode);
}

/*****************************************************************************/
/* 	  A/D EAB Rg[ SCN f[^o^ēݒ				 */
/* 	  wLogSlot	foCX										 */
/*		  peab		EAB Rg[ɐݒ肷̃AhX				 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdSetEab(WORD wLogSlot, PCAISA25ADE peab)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdSetEab])(wLogSlot, peab);
}

/*****************************************************************************/
/* 	  A/D TvOJn(foCX̃{[hw)			 */
/* 	  wLogSlot foCX											 */
/*		  wSelBoard {[h											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdStartSamplingEx(WORD wLogSlot, WORD wSelBoard)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdStartSamplingEx])(wLogSlot, wSelBoard);
}

/*****************************************************************************/
/* 	  A/D TvO~(foCX̃{[hw)			 */
/* 	  wLogSlot foCX											 */
/*		  wSelBoard {[h											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdStopSamplingEx(WORD wLogSlot, WORD wSelBoard)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdStopSamplingEx])(wLogSlot, wSelBoard);
}

/*****************************************************************************/
/* 	  A/D TvȌԂ擾(foCX̃{[hw)	 */
/* 	  wLogSlot	 foCX										 */
/*		  wSelBoard	 {[h											 */
/*		  pdwNumData TvOς݃f[^i[̈ւ̃AhX		 */
/*		  pdwStatus	 TvOԂ̃Xe[^Xi[̈ւ̃AhX	 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdGetSamplingStatusEx(WORD wLogSlot, WORD wSelBoard, PDWORD pdwNumData, PDWORD pdwStatus)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdGetSamplingStatusEx])(wLogSlot, wSelBoard, pdwNumData, pdwStatus);
}

/*****************************************************************************/
/* 	  A/D TvOf[^̎擾(foCX̃{[hw)	 */
/* 	  wLogSlot	 foCX										 */
/*		  wSelBoard	 {[h											 */
/*		  pdwNumData 擾f[^(ۂɎ擾f[^)				 */
/*		  pwData	 f[^obt@ւ̃AhX								 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wAdGetDataEx(WORD wLogSlot, WORD wSelBoard, PDWORD pdwNumData, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiAdGetDataEx])(wLogSlot, wSelBoard, pdwNumData, pwData);
}

/*****************************************************************************/
/* 	  D/A TvOx̐ݒ(foCX̃{[hw)		 */
/* 	  wLogSlot	 foCX										 */
/*		  wSelBoard	 {[h											 */
/*		  dwSelClock D/A TvONbNݒ							 */
/*		  dwTimer	 D/A TvO^Cݒ								 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaSetRateSamplingEx(WORD wLogSlot, WORD wSelBoard, DWORD dwSelClock, DWORD dwTimer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaSetRateSamplingEx])(wLogSlot, wSelBoard, dwSelClock, dwTimer);
}

/*****************************************************************************/
/* 	  D/A f[^̓o^(foCX̃{[hw)				 */
/* 	  wLogSlot	  foCX										 */
/*		  wSelBoard	  {[h										 */
/*		  dwDaMode	  D/A TvOf[^o^̑I						 */
/*		  dwDataCount ރf[^̌									 */
/*		  pwDataEntry D/A f[^ݒ肷z								 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaSetDataEntryEx(WORD wLogSlot, WORD wSelBoard, DWORD dwDaMode, DWORD dwDataCount, PWORD pwDataEntry)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaSetDataEntryEx])(wLogSlot, wSelBoard, dwDaMode, dwDataCount, pwDataEntry);
}

/*****************************************************************************/
/* 	  D/A TvOJn(foCX̃{[hw)			 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/*		  dwDaMode D/A TvO[h̑I								 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaStartSamplingEx(WORD wLogSlot, WORD wSelBoard, DWORD dwDaMode)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaStartSamplingEx])(wLogSlot, wSelBoard, dwDaMode);
}

/*****************************************************************************/
/* 	  D/A TvO~(foCX̃{[hw)			 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaStopSamplingEx(WORD wLogSlot, WORD wSelBoard)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaStopSamplingEx])(wLogSlot, wSelBoard);
}

/*****************************************************************************/
/* 	  D/A f[^o(foCX̃{[hw)				 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/*		  wDaData	o͂ D/A f[^										 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wDaSetDataEx(WORD wLogSlot, WORD wSelBoard, WORD wDaData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiDaSetDataEx])(wLogSlot, wSelBoard, wDaData);
}

/*****************************************************************************/
/* 	  ėp̓|[gf[^擾(foCX̃{[hw)		 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/*		  pdwEIn1	EIn1 ̏												 */
/*		  pdwEIn2	EIn2 ̏												 */
/*		  pdwEIn3	EIn3 ̏												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wGetEInEx(WORD wLogSlot, WORD wSelBoard, PDWORD pdwEIn1, PDWORD pdwEIn2, PDWORD pdwEIn3)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiGetEInEx])(wLogSlot, wSelBoard, pdwEIn1, pdwEIn2, pdwEIn3);
}

/*****************************************************************************/
/* 	  ėpo̓|[gf[^̐ݒ(foCX̃{[hw)		 */
/* 	  wLogSlot	foCX										 */
/*		  wSelBoard {[h											 */
/*		  dwEOut1	EOut1 ̏											 */
/*		  dwEOut2	EOut2 ̏											 */
/*		  dwEOut3	EOut3 ̏											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa25wSetEOutEx(WORD wLogSlot, WORD wSelBoard, DWORD dwEOut1, DWORD dwEOut2, DWORD dwEOut3)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa25[ApiSetEOutEx])(wLogSlot, wSelBoard, dwEOut1, dwEOut2, dwEOut3);
}

/*****************************************************************************/
/* 	  aISA-A25̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Aisa25wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return AISA25_ERR_WRAPDLL;

	return (*pAisa25[ApiGetLastError])(wLogSlot);
}

// GNX|[g֐
const static PTCHAR szApiName[] =
{
	_T("Aisa25GetVersion"),
	_T("Aisa25Create"),
	_T("Aisa25Close"),
	_T("Aisa25GetResource"),
	_T("Aisa25GetNumBoard"),
	_T("Aisa25GetSwitchValue"),
	_T("Aisa25Reset"),
	_T("Aisa25Adc"),
	_T("Aisa25AdGetChEntry"),
	_T("Aisa25AdSetChEntry"),
	_T("Aisa25AdSetMode"),
	_T("Aisa25AdStartSampling"),
	_T("Aisa25AdStopSampling"),
	_T("Aisa25AdGetSamplingStatus"),
	_T("Aisa25AdGetData"),
	_T("Aisa25DaSetRateSampling"),
	_T("Aisa25DaSetDataEntry"),
	_T("Aisa25DaStartSampling"),
	_T("Aisa25DaStopSampling"),
	_T("Aisa25DaSetData"),
	_T("Aisa25GetEIn"),
	_T("Aisa25SetEOut"),
	_T("Aisa25GetLastError"),
	_T("Aisa25GetSwitchValueEx"),
	_T("Aisa25ResetEx"),
	_T("Aisa25AdcEx"),
	_T("Aisa25AdGetChEntryEx"),
	_T("Aisa25AdSetChEntryEx"),
	_T("Aisa25AdSetModeEx"),
	_T("Aisa25AdSetEab"),
	_T("Aisa25AdStartSamplingEx"),
	_T("Aisa25AdStopSamplingEx"),
	_T("Aisa25AdGetSamplingStatusEx"),
	_T("Aisa25AdGetDataEx"),
	_T("Aisa25DaSetRateSamplingEx"),
	_T("Aisa25DaSetDataEntryEx"),
	_T("Aisa25DaStartSamplingEx"),
	_T("Aisa25DaStopSamplingEx"),
	_T("Aisa25DaSetDataEx"),
	_T("Aisa25GetEInEx"),
	_T("Aisa25SetEOutEx")
};

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Aisa25wGetDllExportFunc()
{
	int i;

	for (i = 0; i < ApiLast; i++)
	{
		pAisa25[i] = GetProcAddress(hDLL, szApiName[i]);
		if (pAisa25[i] == NULL)
			return FALSE;
	}

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
